/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2014-2021 Broadcom
 * All rights reserved.
 */

/* date: Thu Sep 16 13:12:05 2021 */

#include "ulp_template_db_enum.h"
#include "ulp_template_db_field.h"
#include "ulp_template_struct.h"
#include "ulp_template_db_tbl.h"

/* Define the template structures */
/*
 * Classification signature table:
 * maps hash id to ulp_class_match_list[] index
 */
uint16_t ulp_class_sig_tbl[BNXT_ULP_CLASS_SIG_TBL_MAX_SZ] = {
	[BNXT_ULP_CLASS_HID_55dd] = 1,
	[BNXT_ULP_CLASS_HID_1df1] = 2,
	[BNXT_ULP_CLASS_HID_3e55] = 3,
	[BNXT_ULP_CLASS_HID_0649] = 4,
	[BNXT_ULP_CLASS_HID_1011] = 5,
	[BNXT_ULP_CLASS_HID_40e9] = 6,
	[BNXT_ULP_CLASS_HID_3e99] = 7,
	[BNXT_ULP_CLASS_HID_06ad] = 8,
	[BNXT_ULP_CLASS_HID_38c7] = 9,
	[BNXT_ULP_CLASS_HID_00fb] = 10,
	[BNXT_ULP_CLASS_HID_24d3] = 11,
	[BNXT_ULP_CLASS_HID_559b] = 12,
	[BNXT_ULP_CLASS_HID_5003] = 13,
	[BNXT_ULP_CLASS_HID_1837] = 14,
	[BNXT_ULP_CLASS_HID_3bef] = 15,
	[BNXT_ULP_CLASS_HID_0403] = 16,
	[BNXT_ULP_CLASS_HID_3d3f] = 17,
	[BNXT_ULP_CLASS_HID_0543] = 18,
	[BNXT_ULP_CLASS_HID_292b] = 19,
	[BNXT_ULP_CLASS_HID_59e3] = 20,
	[BNXT_ULP_CLASS_HID_5d3b] = 21,
	[BNXT_ULP_CLASS_HID_254f] = 22,
	[BNXT_ULP_CLASS_HID_4917] = 23,
	[BNXT_ULP_CLASS_HID_113b] = 24,
	[BNXT_ULP_CLASS_HID_55fd] = 25,
	[BNXT_ULP_CLASS_HID_1dd1] = 26,
	[BNXT_ULP_CLASS_HID_3e75] = 27,
	[BNXT_ULP_CLASS_HID_0669] = 28,
	[BNXT_ULP_CLASS_HID_1ba1] = 29,
	[BNXT_ULP_CLASS_HID_4c69] = 30,
	[BNXT_ULP_CLASS_HID_0439] = 31,
	[BNXT_ULP_CLASS_HID_34e1] = 32,
	[BNXT_ULP_CLASS_HID_0465] = 33,
	[BNXT_ULP_CLASS_HID_352d] = 34,
	[BNXT_ULP_CLASS_HID_55b1] = 35,
	[BNXT_ULP_CLASS_HID_1da5] = 36,
	[BNXT_ULP_CLASS_HID_32fd] = 37,
	[BNXT_ULP_CLASS_HID_63a5] = 38,
	[BNXT_ULP_CLASS_HID_1b75] = 39,
	[BNXT_ULP_CLASS_HID_4c3d] = 40,
	[BNXT_ULP_CLASS_HID_1031] = 41,
	[BNXT_ULP_CLASS_HID_40c9] = 42,
	[BNXT_ULP_CLASS_HID_3eb9] = 43,
	[BNXT_ULP_CLASS_HID_068d] = 44,
	[BNXT_ULP_CLASS_HID_5039] = 45,
	[BNXT_ULP_CLASS_HID_180d] = 46,
	[BNXT_ULP_CLASS_HID_15fd] = 47,
	[BNXT_ULP_CLASS_HID_46b5] = 48,
	[BNXT_ULP_CLASS_HID_303d] = 49,
	[BNXT_ULP_CLASS_HID_60f5] = 50,
	[BNXT_ULP_CLASS_HID_5ea5] = 51,
	[BNXT_ULP_CLASS_HID_2689] = 52,
	[BNXT_ULP_CLASS_HID_0771] = 53,
	[BNXT_ULP_CLASS_HID_3809] = 54,
	[BNXT_ULP_CLASS_HID_35f9] = 55,
	[BNXT_ULP_CLASS_HID_66b1] = 56,
	[BNXT_ULP_CLASS_HID_559d] = 57,
	[BNXT_ULP_CLASS_HID_1db1] = 58,
	[BNXT_ULP_CLASS_HID_3e15] = 59,
	[BNXT_ULP_CLASS_HID_0609] = 60,
	[BNXT_ULP_CLASS_HID_1bc1] = 61,
	[BNXT_ULP_CLASS_HID_4c09] = 62,
	[BNXT_ULP_CLASS_HID_0459] = 63,
	[BNXT_ULP_CLASS_HID_3481] = 64,
	[BNXT_ULP_CLASS_HID_0405] = 65,
	[BNXT_ULP_CLASS_HID_354d] = 66,
	[BNXT_ULP_CLASS_HID_55d1] = 67,
	[BNXT_ULP_CLASS_HID_1dc5] = 68,
	[BNXT_ULP_CLASS_HID_329d] = 69,
	[BNXT_ULP_CLASS_HID_63c5] = 70,
	[BNXT_ULP_CLASS_HID_1b15] = 71,
	[BNXT_ULP_CLASS_HID_4c5d] = 72,
	[BNXT_ULP_CLASS_HID_1051] = 73,
	[BNXT_ULP_CLASS_HID_40a9] = 74,
	[BNXT_ULP_CLASS_HID_3ed9] = 75,
	[BNXT_ULP_CLASS_HID_06ed] = 76,
	[BNXT_ULP_CLASS_HID_5059] = 77,
	[BNXT_ULP_CLASS_HID_186d] = 78,
	[BNXT_ULP_CLASS_HID_159d] = 79,
	[BNXT_ULP_CLASS_HID_46d5] = 80,
	[BNXT_ULP_CLASS_HID_305d] = 81,
	[BNXT_ULP_CLASS_HID_6095] = 82,
	[BNXT_ULP_CLASS_HID_5ec5] = 83,
	[BNXT_ULP_CLASS_HID_26e9] = 84,
	[BNXT_ULP_CLASS_HID_0711] = 85,
	[BNXT_ULP_CLASS_HID_3869] = 86,
	[BNXT_ULP_CLASS_HID_3599] = 87,
	[BNXT_ULP_CLASS_HID_66d1] = 88,
	[BNXT_ULP_CLASS_HID_38e7] = 89,
	[BNXT_ULP_CLASS_HID_00db] = 90,
	[BNXT_ULP_CLASS_HID_24f3] = 91,
	[BNXT_ULP_CLASS_HID_55bb] = 92,
	[BNXT_ULP_CLASS_HID_5023] = 93,
	[BNXT_ULP_CLASS_HID_1817] = 94,
	[BNXT_ULP_CLASS_HID_3bcf] = 95,
	[BNXT_ULP_CLASS_HID_0423] = 96,
	[BNXT_ULP_CLASS_HID_58e3] = 97,
	[BNXT_ULP_CLASS_HID_20d7] = 98,
	[BNXT_ULP_CLASS_HID_448f] = 99,
	[BNXT_ULP_CLASS_HID_0ce3] = 100,
	[BNXT_ULP_CLASS_HID_076b] = 101,
	[BNXT_ULP_CLASS_HID_3813] = 102,
	[BNXT_ULP_CLASS_HID_5bcb] = 103,
	[BNXT_ULP_CLASS_HID_243f] = 104,
	[BNXT_ULP_CLASS_HID_144b] = 105,
	[BNXT_ULP_CLASS_HID_4573] = 106,
	[BNXT_ULP_CLASS_HID_0057] = 107,
	[BNXT_ULP_CLASS_HID_311f] = 108,
	[BNXT_ULP_CLASS_HID_2b87] = 109,
	[BNXT_ULP_CLASS_HID_5c4f] = 110,
	[BNXT_ULP_CLASS_HID_1793] = 111,
	[BNXT_ULP_CLASS_HID_485b] = 112,
	[BNXT_ULP_CLASS_HID_3447] = 113,
	[BNXT_ULP_CLASS_HID_650f] = 114,
	[BNXT_ULP_CLASS_HID_2053] = 115,
	[BNXT_ULP_CLASS_HID_511b] = 116,
	[BNXT_ULP_CLASS_HID_4b83] = 117,
	[BNXT_ULP_CLASS_HID_13f7] = 118,
	[BNXT_ULP_CLASS_HID_37af] = 119,
	[BNXT_ULP_CLASS_HID_6857] = 120,
	[BNXT_ULP_CLASS_HID_3d1f] = 121,
	[BNXT_ULP_CLASS_HID_0563] = 122,
	[BNXT_ULP_CLASS_HID_290b] = 123,
	[BNXT_ULP_CLASS_HID_59c3] = 124,
	[BNXT_ULP_CLASS_HID_5d1b] = 125,
	[BNXT_ULP_CLASS_HID_256f] = 126,
	[BNXT_ULP_CLASS_HID_4937] = 127,
	[BNXT_ULP_CLASS_HID_111b] = 128,
	[BNXT_ULP_CLASS_HID_5f4b] = 129,
	[BNXT_ULP_CLASS_HID_275f] = 130,
	[BNXT_ULP_CLASS_HID_4b67] = 131,
	[BNXT_ULP_CLASS_HID_134b] = 132,
	[BNXT_ULP_CLASS_HID_1683] = 133,
	[BNXT_ULP_CLASS_HID_475b] = 134,
	[BNXT_ULP_CLASS_HID_02bf] = 135,
	[BNXT_ULP_CLASS_HID_3377] = 136,
	[BNXT_ULP_CLASS_HID_19db] = 137,
	[BNXT_ULP_CLASS_HID_4a93] = 138,
	[BNXT_ULP_CLASS_HID_05f7] = 139,
	[BNXT_ULP_CLASS_HID_368f] = 140,
	[BNXT_ULP_CLASS_HID_39c7] = 141,
	[BNXT_ULP_CLASS_HID_022b] = 142,
	[BNXT_ULP_CLASS_HID_25f3] = 143,
	[BNXT_ULP_CLASS_HID_568b] = 144,
	[BNXT_ULP_CLASS_HID_3c37] = 145,
	[BNXT_ULP_CLASS_HID_041b] = 146,
	[BNXT_ULP_CLASS_HID_2823] = 147,
	[BNXT_ULP_CLASS_HID_58fb] = 148,
	[BNXT_ULP_CLASS_HID_5c33] = 149,
	[BNXT_ULP_CLASS_HID_2407] = 150,
	[BNXT_ULP_CLASS_HID_482f] = 151,
	[BNXT_ULP_CLASS_HID_1033] = 152,
	[BNXT_ULP_CLASS_HID_3887] = 153,
	[BNXT_ULP_CLASS_HID_00bb] = 154,
	[BNXT_ULP_CLASS_HID_2493] = 155,
	[BNXT_ULP_CLASS_HID_55db] = 156,
	[BNXT_ULP_CLASS_HID_5043] = 157,
	[BNXT_ULP_CLASS_HID_1877] = 158,
	[BNXT_ULP_CLASS_HID_3baf] = 159,
	[BNXT_ULP_CLASS_HID_0443] = 160,
	[BNXT_ULP_CLASS_HID_5883] = 161,
	[BNXT_ULP_CLASS_HID_20b7] = 162,
	[BNXT_ULP_CLASS_HID_44ef] = 163,
	[BNXT_ULP_CLASS_HID_0c83] = 164,
	[BNXT_ULP_CLASS_HID_070b] = 165,
	[BNXT_ULP_CLASS_HID_3873] = 166,
	[BNXT_ULP_CLASS_HID_5bab] = 167,
	[BNXT_ULP_CLASS_HID_245f] = 168,
	[BNXT_ULP_CLASS_HID_142b] = 169,
	[BNXT_ULP_CLASS_HID_4513] = 170,
	[BNXT_ULP_CLASS_HID_0037] = 171,
	[BNXT_ULP_CLASS_HID_317f] = 172,
	[BNXT_ULP_CLASS_HID_2be7] = 173,
	[BNXT_ULP_CLASS_HID_5c2f] = 174,
	[BNXT_ULP_CLASS_HID_17f3] = 175,
	[BNXT_ULP_CLASS_HID_483b] = 176,
	[BNXT_ULP_CLASS_HID_3427] = 177,
	[BNXT_ULP_CLASS_HID_656f] = 178,
	[BNXT_ULP_CLASS_HID_2033] = 179,
	[BNXT_ULP_CLASS_HID_517b] = 180,
	[BNXT_ULP_CLASS_HID_4be3] = 181,
	[BNXT_ULP_CLASS_HID_1397] = 182,
	[BNXT_ULP_CLASS_HID_37cf] = 183,
	[BNXT_ULP_CLASS_HID_6837] = 184,
	[BNXT_ULP_CLASS_HID_3d7f] = 185,
	[BNXT_ULP_CLASS_HID_0503] = 186,
	[BNXT_ULP_CLASS_HID_296b] = 187,
	[BNXT_ULP_CLASS_HID_59a3] = 188,
	[BNXT_ULP_CLASS_HID_5d7b] = 189,
	[BNXT_ULP_CLASS_HID_250f] = 190,
	[BNXT_ULP_CLASS_HID_4957] = 191,
	[BNXT_ULP_CLASS_HID_117b] = 192,
	[BNXT_ULP_CLASS_HID_5f2b] = 193,
	[BNXT_ULP_CLASS_HID_273f] = 194,
	[BNXT_ULP_CLASS_HID_4b07] = 195,
	[BNXT_ULP_CLASS_HID_132b] = 196,
	[BNXT_ULP_CLASS_HID_16e3] = 197,
	[BNXT_ULP_CLASS_HID_473b] = 198,
	[BNXT_ULP_CLASS_HID_02df] = 199,
	[BNXT_ULP_CLASS_HID_3317] = 200,
	[BNXT_ULP_CLASS_HID_19bb] = 201,
	[BNXT_ULP_CLASS_HID_4af3] = 202,
	[BNXT_ULP_CLASS_HID_0597] = 203,
	[BNXT_ULP_CLASS_HID_36ef] = 204,
	[BNXT_ULP_CLASS_HID_39a7] = 205,
	[BNXT_ULP_CLASS_HID_024b] = 206,
	[BNXT_ULP_CLASS_HID_2593] = 207,
	[BNXT_ULP_CLASS_HID_56eb] = 208,
	[BNXT_ULP_CLASS_HID_3c57] = 209,
	[BNXT_ULP_CLASS_HID_047b] = 210,
	[BNXT_ULP_CLASS_HID_2843] = 211,
	[BNXT_ULP_CLASS_HID_589b] = 212,
	[BNXT_ULP_CLASS_HID_5c53] = 213,
	[BNXT_ULP_CLASS_HID_2467] = 214,
	[BNXT_ULP_CLASS_HID_484f] = 215,
	[BNXT_ULP_CLASS_HID_1053] = 216,
	[BNXT_ULP_CLASS_HID_5ce1] = 217,
	[BNXT_ULP_CLASS_HID_4579] = 218,
	[BNXT_ULP_CLASS_HID_1735] = 219,
	[BNXT_ULP_CLASS_HID_45bd] = 220,
	[BNXT_ULP_CLASS_HID_3feb] = 221,
	[BNXT_ULP_CLASS_HID_2bf7] = 222,
	[BNXT_ULP_CLASS_HID_5727] = 223,
	[BNXT_ULP_CLASS_HID_4333] = 224,
	[BNXT_ULP_CLASS_HID_4453] = 225,
	[BNXT_ULP_CLASS_HID_304f] = 226,
	[BNXT_ULP_CLASS_HID_645f] = 227,
	[BNXT_ULP_CLASS_HID_504b] = 228,
	[BNXT_ULP_CLASS_HID_5cc1] = 229,
	[BNXT_ULP_CLASS_HID_4559] = 230,
	[BNXT_ULP_CLASS_HID_2285] = 231,
	[BNXT_ULP_CLASS_HID_0b1d] = 232,
	[BNXT_ULP_CLASS_HID_0b49] = 233,
	[BNXT_ULP_CLASS_HID_5c95] = 234,
	[BNXT_ULP_CLASS_HID_39c1] = 235,
	[BNXT_ULP_CLASS_HID_2259] = 236,
	[BNXT_ULP_CLASS_HID_1715] = 237,
	[BNXT_ULP_CLASS_HID_459d] = 238,
	[BNXT_ULP_CLASS_HID_571d] = 239,
	[BNXT_ULP_CLASS_HID_1cd1] = 240,
	[BNXT_ULP_CLASS_HID_3711] = 241,
	[BNXT_ULP_CLASS_HID_6599] = 242,
	[BNXT_ULP_CLASS_HID_0e55] = 243,
	[BNXT_ULP_CLASS_HID_3cdd] = 244,
	[BNXT_ULP_CLASS_HID_5ca1] = 245,
	[BNXT_ULP_CLASS_HID_4539] = 246,
	[BNXT_ULP_CLASS_HID_22e5] = 247,
	[BNXT_ULP_CLASS_HID_0b7d] = 248,
	[BNXT_ULP_CLASS_HID_0b29] = 249,
	[BNXT_ULP_CLASS_HID_5cf5] = 250,
	[BNXT_ULP_CLASS_HID_39a1] = 251,
	[BNXT_ULP_CLASS_HID_2239] = 252,
	[BNXT_ULP_CLASS_HID_1775] = 253,
	[BNXT_ULP_CLASS_HID_45fd] = 254,
	[BNXT_ULP_CLASS_HID_577d] = 255,
	[BNXT_ULP_CLASS_HID_1cb1] = 256,
	[BNXT_ULP_CLASS_HID_3771] = 257,
	[BNXT_ULP_CLASS_HID_65f9] = 258,
	[BNXT_ULP_CLASS_HID_0e35] = 259,
	[BNXT_ULP_CLASS_HID_3cbd] = 260,
	[BNXT_ULP_CLASS_HID_3fcb] = 261,
	[BNXT_ULP_CLASS_HID_2bd7] = 262,
	[BNXT_ULP_CLASS_HID_5707] = 263,
	[BNXT_ULP_CLASS_HID_4313] = 264,
	[BNXT_ULP_CLASS_HID_5fc7] = 265,
	[BNXT_ULP_CLASS_HID_4bd3] = 266,
	[BNXT_ULP_CLASS_HID_0e4f] = 267,
	[BNXT_ULP_CLASS_HID_632f] = 268,
	[BNXT_ULP_CLASS_HID_1baf] = 269,
	[BNXT_ULP_CLASS_HID_07bb] = 270,
	[BNXT_ULP_CLASS_HID_32eb] = 271,
	[BNXT_ULP_CLASS_HID_1ef7] = 272,
	[BNXT_ULP_CLASS_HID_3bab] = 273,
	[BNXT_ULP_CLASS_HID_27b7] = 274,
	[BNXT_ULP_CLASS_HID_52e7] = 275,
	[BNXT_ULP_CLASS_HID_3ef3] = 276,
	[BNXT_ULP_CLASS_HID_4473] = 277,
	[BNXT_ULP_CLASS_HID_306f] = 278,
	[BNXT_ULP_CLASS_HID_647f] = 279,
	[BNXT_ULP_CLASS_HID_506b] = 280,
	[BNXT_ULP_CLASS_HID_66af] = 281,
	[BNXT_ULP_CLASS_HID_525b] = 282,
	[BNXT_ULP_CLASS_HID_1de7] = 283,
	[BNXT_ULP_CLASS_HID_0993] = 284,
	[BNXT_ULP_CLASS_HID_213f] = 285,
	[BNXT_ULP_CLASS_HID_0d2b] = 286,
	[BNXT_ULP_CLASS_HID_413b] = 287,
	[BNXT_ULP_CLASS_HID_2cd7] = 288,
	[BNXT_ULP_CLASS_HID_436b] = 289,
	[BNXT_ULP_CLASS_HID_2f07] = 290,
	[BNXT_ULP_CLASS_HID_6317] = 291,
	[BNXT_ULP_CLASS_HID_4f03] = 292,
	[BNXT_ULP_CLASS_HID_3fab] = 293,
	[BNXT_ULP_CLASS_HID_2bb7] = 294,
	[BNXT_ULP_CLASS_HID_5767] = 295,
	[BNXT_ULP_CLASS_HID_4373] = 296,
	[BNXT_ULP_CLASS_HID_5fa7] = 297,
	[BNXT_ULP_CLASS_HID_4bb3] = 298,
	[BNXT_ULP_CLASS_HID_0e2f] = 299,
	[BNXT_ULP_CLASS_HID_634f] = 300,
	[BNXT_ULP_CLASS_HID_1bcf] = 301,
	[BNXT_ULP_CLASS_HID_07db] = 302,
	[BNXT_ULP_CLASS_HID_328b] = 303,
	[BNXT_ULP_CLASS_HID_1e97] = 304,
	[BNXT_ULP_CLASS_HID_3bcb] = 305,
	[BNXT_ULP_CLASS_HID_27d7] = 306,
	[BNXT_ULP_CLASS_HID_5287] = 307,
	[BNXT_ULP_CLASS_HID_3e93] = 308,
	[BNXT_ULP_CLASS_HID_4413] = 309,
	[BNXT_ULP_CLASS_HID_300f] = 310,
	[BNXT_ULP_CLASS_HID_641f] = 311,
	[BNXT_ULP_CLASS_HID_500b] = 312,
	[BNXT_ULP_CLASS_HID_66cf] = 313,
	[BNXT_ULP_CLASS_HID_523b] = 314,
	[BNXT_ULP_CLASS_HID_1d87] = 315,
	[BNXT_ULP_CLASS_HID_09f3] = 316,
	[BNXT_ULP_CLASS_HID_215f] = 317,
	[BNXT_ULP_CLASS_HID_0d4b] = 318,
	[BNXT_ULP_CLASS_HID_415b] = 319,
	[BNXT_ULP_CLASS_HID_2cb7] = 320,
	[BNXT_ULP_CLASS_HID_430b] = 321,
	[BNXT_ULP_CLASS_HID_2f67] = 322,
	[BNXT_ULP_CLASS_HID_6377] = 323,
	[BNXT_ULP_CLASS_HID_4f63] = 324,
	[BNXT_ULP_CLASS_HID_29b5] = 325,
	[BNXT_ULP_CLASS_HID_29ad] = 326,
	[BNXT_ULP_CLASS_HID_29b7] = 327,
	[BNXT_ULP_CLASS_HID_1583] = 328,
	[BNXT_ULP_CLASS_HID_29af] = 329,
	[BNXT_ULP_CLASS_HID_159b] = 330,
	[BNXT_ULP_CLASS_HID_2995] = 331,
	[BNXT_ULP_CLASS_HID_298d] = 332,
	[BNXT_ULP_CLASS_HID_29f5] = 333,
	[BNXT_ULP_CLASS_HID_29ed] = 334,
	[BNXT_ULP_CLASS_HID_2997] = 335,
	[BNXT_ULP_CLASS_HID_15a3] = 336,
	[BNXT_ULP_CLASS_HID_298f] = 337,
	[BNXT_ULP_CLASS_HID_15bb] = 338,
	[BNXT_ULP_CLASS_HID_29f7] = 339,
	[BNXT_ULP_CLASS_HID_15c3] = 340,
	[BNXT_ULP_CLASS_HID_29ef] = 341,
	[BNXT_ULP_CLASS_HID_15db] = 342,
	[BNXT_ULP_CLASS_HID_1151] = 343,
	[BNXT_ULP_CLASS_HID_315d] = 344,
	[BNXT_ULP_CLASS_HID_3612] = 345,
	[BNXT_ULP_CLASS_HID_66da] = 346,
	[BNXT_ULP_CLASS_HID_e082] = 347,
	[BNXT_ULP_CLASS_HID_ab46] = 348,
	[BNXT_ULP_CLASS_HID_c82a] = 349,
	[BNXT_ULP_CLASS_HID_f9a2] = 350,
	[BNXT_ULP_CLASS_HID_d8ce] = 351,
	[BNXT_ULP_CLASS_HID_a2d2] = 352,
	[BNXT_ULP_CLASS_HID_c076] = 353,
	[BNXT_ULP_CLASS_HID_f1ee] = 354,
	[BNXT_ULP_CLASS_HID_a96e] = 355,
	[BNXT_ULP_CLASS_HID_dae6] = 356,
	[BNXT_ULP_CLASS_HID_c7aa] = 357,
	[BNXT_ULP_CLASS_HID_c26e] = 358,
	[BNXT_ULP_CLASS_HID_a0fa] = 359,
	[BNXT_ULP_CLASS_HID_d272] = 360,
	[BNXT_ULP_CLASS_HID_fff6] = 361,
	[BNXT_ULP_CLASS_HID_e16e] = 362,
	[BNXT_ULP_CLASS_HID_e165] = 363,
	[BNXT_ULP_CLASS_HID_aaa1] = 364,
	[BNXT_ULP_CLASS_HID_c9cd] = 365,
	[BNXT_ULP_CLASS_HID_f845] = 366,
	[BNXT_ULP_CLASS_HID_90f9] = 367,
	[BNXT_ULP_CLASS_HID_c371] = 368,
	[BNXT_ULP_CLASS_HID_e19d] = 369,
	[BNXT_ULP_CLASS_HID_d015] = 370,
	[BNXT_ULP_CLASS_HID_8c09] = 371,
	[BNXT_ULP_CLASS_HID_be89] = 372,
	[BNXT_ULP_CLASS_HID_ddad] = 373,
	[BNXT_ULP_CLASS_HID_cc2d] = 374,
	[BNXT_ULP_CLASS_HID_a4d9] = 375,
	[BNXT_ULP_CLASS_HID_d759] = 376,
	[BNXT_ULP_CLASS_HID_f27d] = 377,
	[BNXT_ULP_CLASS_HID_e4fd] = 378,
	[BNXT_ULP_CLASS_HID_ecf6] = 379,
	[BNXT_ULP_CLASS_HID_a732] = 380,
	[BNXT_ULP_CLASS_HID_c45e] = 381,
	[BNXT_ULP_CLASS_HID_f5d6] = 382,
	[BNXT_ULP_CLASS_HID_d4ba] = 383,
	[BNXT_ULP_CLASS_HID_aea6] = 384,
	[BNXT_ULP_CLASS_HID_cc02] = 385,
	[BNXT_ULP_CLASS_HID_fd9a] = 386,
	[BNXT_ULP_CLASS_HID_a51a] = 387,
	[BNXT_ULP_CLASS_HID_d692] = 388,
	[BNXT_ULP_CLASS_HID_cbde] = 389,
	[BNXT_ULP_CLASS_HID_ce1a] = 390,
	[BNXT_ULP_CLASS_HID_ac8e] = 391,
	[BNXT_ULP_CLASS_HID_de06] = 392,
	[BNXT_ULP_CLASS_HID_f382] = 393,
	[BNXT_ULP_CLASS_HID_ed1a] = 394,
	[BNXT_ULP_CLASS_HID_9d6a] = 395,
	[BNXT_ULP_CLASS_HID_cee2] = 396,
	[BNXT_ULP_CLASS_HID_ec0e] = 397,
	[BNXT_ULP_CLASS_HID_dd86] = 398,
	[BNXT_ULP_CLASS_HID_852e] = 399,
	[BNXT_ULP_CLASS_HID_b6a6] = 400,
	[BNXT_ULP_CLASS_HID_eb82] = 401,
	[BNXT_ULP_CLASS_HID_c50a] = 402,
	[BNXT_ULP_CLASS_HID_ccca] = 403,
	[BNXT_ULP_CLASS_HID_8706] = 404,
	[BNXT_ULP_CLASS_HID_d38e] = 405,
	[BNXT_ULP_CLASS_HID_d5ca] = 406,
	[BNXT_ULP_CLASS_HID_b48e] = 407,
	[BNXT_ULP_CLASS_HID_8e8a] = 408,
	[BNXT_ULP_CLASS_HID_db02] = 409,
	[BNXT_ULP_CLASS_HID_dd8e] = 410,
	[BNXT_ULP_CLASS_HID_819a] = 411,
	[BNXT_ULP_CLASS_HID_b31a] = 412,
	[BNXT_ULP_CLASS_HID_d03e] = 413,
	[BNXT_ULP_CLASS_HID_c1be] = 414,
	[BNXT_ULP_CLASS_HID_890e] = 415,
	[BNXT_ULP_CLASS_HID_ba8e] = 416,
	[BNXT_ULP_CLASS_HID_dfaa] = 417,
	[BNXT_ULP_CLASS_HID_c93a] = 418,
	[BNXT_ULP_CLASS_HID_b11a] = 419,
	[BNXT_ULP_CLASS_HID_8b4e] = 420,
	[BNXT_ULP_CLASS_HID_c79e] = 421,
	[BNXT_ULP_CLASS_HID_d9da] = 422,
	[BNXT_ULP_CLASS_HID_b88e] = 423,
	[BNXT_ULP_CLASS_HID_ea0e] = 424,
	[BNXT_ULP_CLASS_HID_cf0a] = 425,
	[BNXT_ULP_CLASS_HID_c18e] = 426,
	[BNXT_ULP_CLASS_HID_a94a] = 427,
	[BNXT_ULP_CLASS_HID_daca] = 428,
	[BNXT_ULP_CLASS_HID_ffee] = 429,
	[BNXT_ULP_CLASS_HID_e96e] = 430,
	[BNXT_ULP_CLASS_HID_910e] = 431,
	[BNXT_ULP_CLASS_HID_c28e] = 432,
	[BNXT_ULP_CLASS_HID_e7aa] = 433,
	[BNXT_ULP_CLASS_HID_d12a] = 434,
	[BNXT_ULP_CLASS_HID_d8ca] = 435,
	[BNXT_ULP_CLASS_HID_930e] = 436,
	[BNXT_ULP_CLASS_HID_ef4e] = 437,
	[BNXT_ULP_CLASS_HID_e18a] = 438,
	[BNXT_ULP_CLASS_HID_c08e] = 439,
	[BNXT_ULP_CLASS_HID_9a8a] = 440,
	[BNXT_ULP_CLASS_HID_d70a] = 441,
	[BNXT_ULP_CLASS_HID_e90e] = 442,
	[BNXT_ULP_CLASS_HID_edd9] = 443,
	[BNXT_ULP_CLASS_HID_a61d] = 444,
	[BNXT_ULP_CLASS_HID_c571] = 445,
	[BNXT_ULP_CLASS_HID_f4f9] = 446,
	[BNXT_ULP_CLASS_HID_9c45] = 447,
	[BNXT_ULP_CLASS_HID_cfcd] = 448,
	[BNXT_ULP_CLASS_HID_ed21] = 449,
	[BNXT_ULP_CLASS_HID_dca9] = 450,
	[BNXT_ULP_CLASS_HID_80b5] = 451,
	[BNXT_ULP_CLASS_HID_b235] = 452,
	[BNXT_ULP_CLASS_HID_d111] = 453,
	[BNXT_ULP_CLASS_HID_c091] = 454,
	[BNXT_ULP_CLASS_HID_a865] = 455,
	[BNXT_ULP_CLASS_HID_dbe5] = 456,
	[BNXT_ULP_CLASS_HID_fec1] = 457,
	[BNXT_ULP_CLASS_HID_e841] = 458,
	[BNXT_ULP_CLASS_HID_8e85] = 459,
	[BNXT_ULP_CLASS_HID_b80d] = 460,
	[BNXT_ULP_CLASS_HID_df65] = 461,
	[BNXT_ULP_CLASS_HID_ceed] = 462,
	[BNXT_ULP_CLASS_HID_9645] = 463,
	[BNXT_ULP_CLASS_HID_c1cd] = 464,
	[BNXT_ULP_CLASS_HID_e725] = 465,
	[BNXT_ULP_CLASS_HID_d6ad] = 466,
	[BNXT_ULP_CLASS_HID_9aa5] = 467,
	[BNXT_ULP_CLASS_HID_b425] = 468,
	[BNXT_ULP_CLASS_HID_eb05] = 469,
	[BNXT_ULP_CLASS_HID_da85] = 470,
	[BNXT_ULP_CLASS_HID_a265] = 471,
	[BNXT_ULP_CLASS_HID_dde5] = 472,
	[BNXT_ULP_CLASS_HID_f0c5] = 473,
	[BNXT_ULP_CLASS_HID_e245] = 474,
	[BNXT_ULP_CLASS_HID_8b8f] = 475,
	[BNXT_ULP_CLASS_HID_a517] = 476,
	[BNXT_ULP_CLASS_HID_d86b] = 477,
	[BNXT_ULP_CLASS_HID_cbf3] = 478,
	[BNXT_ULP_CLASS_HID_934f] = 479,
	[BNXT_ULP_CLASS_HID_c2c7] = 480,
	[BNXT_ULP_CLASS_HID_e02b] = 481,
	[BNXT_ULP_CLASS_HID_d3a3] = 482,
	[BNXT_ULP_CLASS_HID_87a7] = 483,
	[BNXT_ULP_CLASS_HID_b137] = 484,
	[BNXT_ULP_CLASS_HID_d403] = 485,
	[BNXT_ULP_CLASS_HID_c793] = 486,
	[BNXT_ULP_CLASS_HID_af67] = 487,
	[BNXT_ULP_CLASS_HID_dee7] = 488,
	[BNXT_ULP_CLASS_HID_fdc3] = 489,
	[BNXT_ULP_CLASS_HID_ef43] = 490,
	[BNXT_ULP_CLASS_HID_8dbf] = 491,
	[BNXT_ULP_CLASS_HID_bf07] = 492,
	[BNXT_ULP_CLASS_HID_d21f] = 493,
	[BNXT_ULP_CLASS_HID_cde7] = 494,
	[BNXT_ULP_CLASS_HID_956f] = 495,
	[BNXT_ULP_CLASS_HID_c4c7] = 496,
	[BNXT_ULP_CLASS_HID_fbcf] = 497,
	[BNXT_ULP_CLASS_HID_d5a7] = 498,
	[BNXT_ULP_CLASS_HID_9957] = 499,
	[BNXT_ULP_CLASS_HID_cb27] = 500,
	[BNXT_ULP_CLASS_HID_ee37] = 501,
	[BNXT_ULP_CLASS_HID_d987] = 502,
	[BNXT_ULP_CLASS_HID_a107] = 503,
	[BNXT_ULP_CLASS_HID_d0e7] = 504,
	[BNXT_ULP_CLASS_HID_f7e7] = 505,
	[BNXT_ULP_CLASS_HID_c827] = 506,
	[BNXT_ULP_CLASS_HID_f76a] = 507,
	[BNXT_ULP_CLASS_HID_bcae] = 508,
	[BNXT_ULP_CLASS_HID_dfc2] = 509,
	[BNXT_ULP_CLASS_HID_ee4a] = 510,
	[BNXT_ULP_CLASS_HID_cf26] = 511,
	[BNXT_ULP_CLASS_HID_b53a] = 512,
	[BNXT_ULP_CLASS_HID_d79e] = 513,
	[BNXT_ULP_CLASS_HID_e606] = 514,
	[BNXT_ULP_CLASS_HID_be86] = 515,
	[BNXT_ULP_CLASS_HID_cd0e] = 516,
	[BNXT_ULP_CLASS_HID_d042] = 517,
	[BNXT_ULP_CLASS_HID_d586] = 518,
	[BNXT_ULP_CLASS_HID_b712] = 519,
	[BNXT_ULP_CLASS_HID_c59a] = 520,
	[BNXT_ULP_CLASS_HID_e81e] = 521,
	[BNXT_ULP_CLASS_HID_f686] = 522,
	[BNXT_ULP_CLASS_HID_86f6] = 523,
	[BNXT_ULP_CLASS_HID_d57e] = 524,
	[BNXT_ULP_CLASS_HID_f792] = 525,
	[BNXT_ULP_CLASS_HID_c61a] = 526,
	[BNXT_ULP_CLASS_HID_9eb2] = 527,
	[BNXT_ULP_CLASS_HID_ad3a] = 528,
	[BNXT_ULP_CLASS_HID_f01e] = 529,
	[BNXT_ULP_CLASS_HID_de96] = 530,
	[BNXT_ULP_CLASS_HID_d756] = 531,
	[BNXT_ULP_CLASS_HID_9c9a] = 532,
	[BNXT_ULP_CLASS_HID_c812] = 533,
	[BNXT_ULP_CLASS_HID_ce56] = 534,
	[BNXT_ULP_CLASS_HID_af12] = 535,
	[BNXT_ULP_CLASS_HID_9516] = 536,
	[BNXT_ULP_CLASS_HID_c09e] = 537,
	[BNXT_ULP_CLASS_HID_c612] = 538,
	[BNXT_ULP_CLASS_HID_9a06] = 539,
	[BNXT_ULP_CLASS_HID_a886] = 540,
	[BNXT_ULP_CLASS_HID_cba2] = 541,
	[BNXT_ULP_CLASS_HID_da22] = 542,
	[BNXT_ULP_CLASS_HID_9292] = 543,
	[BNXT_ULP_CLASS_HID_a112] = 544,
	[BNXT_ULP_CLASS_HID_c436] = 545,
	[BNXT_ULP_CLASS_HID_d2a6] = 546,
	[BNXT_ULP_CLASS_HID_aa86] = 547,
	[BNXT_ULP_CLASS_HID_90d2] = 548,
	[BNXT_ULP_CLASS_HID_dc02] = 549,
	[BNXT_ULP_CLASS_HID_c246] = 550,
	[BNXT_ULP_CLASS_HID_a312] = 551,
	[BNXT_ULP_CLASS_HID_f192] = 552,
	[BNXT_ULP_CLASS_HID_d496] = 553,
	[BNXT_ULP_CLASS_HID_da12] = 554,
	[BNXT_ULP_CLASS_HID_b2d6] = 555,
	[BNXT_ULP_CLASS_HID_c156] = 556,
	[BNXT_ULP_CLASS_HID_e472] = 557,
	[BNXT_ULP_CLASS_HID_f2f2] = 558,
	[BNXT_ULP_CLASS_HID_8a92] = 559,
	[BNXT_ULP_CLASS_HID_d912] = 560,
	[BNXT_ULP_CLASS_HID_fc36] = 561,
	[BNXT_ULP_CLASS_HID_cab6] = 562,
	[BNXT_ULP_CLASS_HID_c356] = 563,
	[BNXT_ULP_CLASS_HID_8892] = 564,
	[BNXT_ULP_CLASS_HID_f4d2] = 565,
	[BNXT_ULP_CLASS_HID_fa16] = 566,
	[BNXT_ULP_CLASS_HID_db12] = 567,
	[BNXT_ULP_CLASS_HID_8116] = 568,
	[BNXT_ULP_CLASS_HID_cc96] = 569,
	[BNXT_ULP_CLASS_HID_f292] = 570,
	[BNXT_ULP_CLASS_HID_e84d] = 571,
	[BNXT_ULP_CLASS_HID_a389] = 572,
	[BNXT_ULP_CLASS_HID_c0e5] = 573,
	[BNXT_ULP_CLASS_HID_f16d] = 574,
	[BNXT_ULP_CLASS_HID_99d1] = 575,
	[BNXT_ULP_CLASS_HID_ca59] = 576,
	[BNXT_ULP_CLASS_HID_e8b5] = 577,
	[BNXT_ULP_CLASS_HID_d93d] = 578,
	[BNXT_ULP_CLASS_HID_8521] = 579,
	[BNXT_ULP_CLASS_HID_b7a1] = 580,
	[BNXT_ULP_CLASS_HID_d485] = 581,
	[BNXT_ULP_CLASS_HID_c505] = 582,
	[BNXT_ULP_CLASS_HID_adf1] = 583,
	[BNXT_ULP_CLASS_HID_de71] = 584,
	[BNXT_ULP_CLASS_HID_fb55] = 585,
	[BNXT_ULP_CLASS_HID_edd5] = 586,
	[BNXT_ULP_CLASS_HID_8b11] = 587,
	[BNXT_ULP_CLASS_HID_bd99] = 588,
	[BNXT_ULP_CLASS_HID_daf1] = 589,
	[BNXT_ULP_CLASS_HID_cb79] = 590,
	[BNXT_ULP_CLASS_HID_93d1] = 591,
	[BNXT_ULP_CLASS_HID_c459] = 592,
	[BNXT_ULP_CLASS_HID_e2b1] = 593,
	[BNXT_ULP_CLASS_HID_d339] = 594,
	[BNXT_ULP_CLASS_HID_9f31] = 595,
	[BNXT_ULP_CLASS_HID_b1b1] = 596,
	[BNXT_ULP_CLASS_HID_ee91] = 597,
	[BNXT_ULP_CLASS_HID_df11] = 598,
	[BNXT_ULP_CLASS_HID_a7f1] = 599,
	[BNXT_ULP_CLASS_HID_d871] = 600,
	[BNXT_ULP_CLASS_HID_f551] = 601,
	[BNXT_ULP_CLASS_HID_e7d1] = 602,
	[BNXT_ULP_CLASS_HID_8e1b] = 603,
	[BNXT_ULP_CLASS_HID_a083] = 604,
	[BNXT_ULP_CLASS_HID_ddff] = 605,
	[BNXT_ULP_CLASS_HID_ce67] = 606,
	[BNXT_ULP_CLASS_HID_96db] = 607,
	[BNXT_ULP_CLASS_HID_c753] = 608,
	[BNXT_ULP_CLASS_HID_e5bf] = 609,
	[BNXT_ULP_CLASS_HID_d637] = 610,
	[BNXT_ULP_CLASS_HID_8233] = 611,
	[BNXT_ULP_CLASS_HID_b4a3] = 612,
	[BNXT_ULP_CLASS_HID_d197] = 613,
	[BNXT_ULP_CLASS_HID_c207] = 614,
	[BNXT_ULP_CLASS_HID_aaf3] = 615,
	[BNXT_ULP_CLASS_HID_db73] = 616,
	[BNXT_ULP_CLASS_HID_f857] = 617,
	[BNXT_ULP_CLASS_HID_ead7] = 618,
	[BNXT_ULP_CLASS_HID_882b] = 619,
	[BNXT_ULP_CLASS_HID_ba93] = 620,
	[BNXT_ULP_CLASS_HID_d78b] = 621,
	[BNXT_ULP_CLASS_HID_c873] = 622,
	[BNXT_ULP_CLASS_HID_90fb] = 623,
	[BNXT_ULP_CLASS_HID_c153] = 624,
	[BNXT_ULP_CLASS_HID_fe5b] = 625,
	[BNXT_ULP_CLASS_HID_d033] = 626,
	[BNXT_ULP_CLASS_HID_9cc3] = 627,
	[BNXT_ULP_CLASS_HID_ceb3] = 628,
	[BNXT_ULP_CLASS_HID_eba3] = 629,
	[BNXT_ULP_CLASS_HID_dc13] = 630,
	[BNXT_ULP_CLASS_HID_a493] = 631,
	[BNXT_ULP_CLASS_HID_d573] = 632,
	[BNXT_ULP_CLASS_HID_f273] = 633,
	[BNXT_ULP_CLASS_HID_cdb3] = 634,
	[BNXT_ULP_CLASS_HID_ff35] = 635,
	[BNXT_ULP_CLASS_HID_b4f1] = 636,
	[BNXT_ULP_CLASS_HID_d79d] = 637,
	[BNXT_ULP_CLASS_HID_e615] = 638,
	[BNXT_ULP_CLASS_HID_8ea9] = 639,
	[BNXT_ULP_CLASS_HID_dd21] = 640,
	[BNXT_ULP_CLASS_HID_ffcd] = 641,
	[BNXT_ULP_CLASS_HID_ce45] = 642,
	[BNXT_ULP_CLASS_HID_9259] = 643,
	[BNXT_ULP_CLASS_HID_a0d9] = 644,
	[BNXT_ULP_CLASS_HID_c3fd] = 645,
	[BNXT_ULP_CLASS_HID_d27d] = 646,
	[BNXT_ULP_CLASS_HID_ba89] = 647,
	[BNXT_ULP_CLASS_HID_c909] = 648,
	[BNXT_ULP_CLASS_HID_ec2d] = 649,
	[BNXT_ULP_CLASS_HID_faad] = 650,
	[BNXT_ULP_CLASS_HID_34c6] = 651,
	[BNXT_ULP_CLASS_HID_0c22] = 652,
	[BNXT_ULP_CLASS_HID_1cbe] = 653,
	[BNXT_ULP_CLASS_HID_179a] = 654,
	[BNXT_ULP_CLASS_HID_59be] = 655,
	[BNXT_ULP_CLASS_HID_515a] = 656,
	[BNXT_ULP_CLASS_HID_1c72] = 657,
	[BNXT_ULP_CLASS_HID_171e] = 658,
	[BNXT_ULP_CLASS_HID_19c8] = 659,
	[BNXT_ULP_CLASS_HID_112c] = 660,
	[BNXT_ULP_CLASS_HID_4d68] = 661,
	[BNXT_ULP_CLASS_HID_444c] = 662,
	[BNXT_ULP_CLASS_HID_0e8c] = 663,
	[BNXT_ULP_CLASS_HID_09e0] = 664,
	[BNXT_ULP_CLASS_HID_1af0] = 665,
	[BNXT_ULP_CLASS_HID_15d4] = 666,
	[BNXT_ULP_CLASS_HID_1dd0] = 667,
	[BNXT_ULP_CLASS_HID_14f4] = 668,
	[BNXT_ULP_CLASS_HID_70b0] = 669,
	[BNXT_ULP_CLASS_HID_4854] = 670,
	[BNXT_ULP_CLASS_HID_3dd4] = 671,
	[BNXT_ULP_CLASS_HID_34f8] = 672,
	[BNXT_ULP_CLASS_HID_09e8] = 673,
	[BNXT_ULP_CLASS_HID_008c] = 674,
	[BNXT_ULP_CLASS_HID_34e6] = 675,
	[BNXT_ULP_CLASS_HID_0c02] = 676,
	[BNXT_ULP_CLASS_HID_1c9e] = 677,
	[BNXT_ULP_CLASS_HID_17ba] = 678,
	[BNXT_ULP_CLASS_HID_429e] = 679,
	[BNXT_ULP_CLASS_HID_5dba] = 680,
	[BNXT_ULP_CLASS_HID_2a16] = 681,
	[BNXT_ULP_CLASS_HID_2532] = 682,
	[BNXT_ULP_CLASS_HID_2da2] = 683,
	[BNXT_ULP_CLASS_HID_24fe] = 684,
	[BNXT_ULP_CLASS_HID_355a] = 685,
	[BNXT_ULP_CLASS_HID_0c76] = 686,
	[BNXT_ULP_CLASS_HID_13e6] = 687,
	[BNXT_ULP_CLASS_HID_7276] = 688,
	[BNXT_ULP_CLASS_HID_42d2] = 689,
	[BNXT_ULP_CLASS_HID_5dee] = 690,
	[BNXT_ULP_CLASS_HID_59de] = 691,
	[BNXT_ULP_CLASS_HID_513a] = 692,
	[BNXT_ULP_CLASS_HID_1c12] = 693,
	[BNXT_ULP_CLASS_HID_177e] = 694,
	[BNXT_ULP_CLASS_HID_0e92] = 695,
	[BNXT_ULP_CLASS_HID_09fe] = 696,
	[BNXT_ULP_CLASS_HID_5c1a] = 697,
	[BNXT_ULP_CLASS_HID_5746] = 698,
	[BNXT_ULP_CLASS_HID_79da] = 699,
	[BNXT_ULP_CLASS_HID_7106] = 700,
	[BNXT_ULP_CLASS_HID_3c1e] = 701,
	[BNXT_ULP_CLASS_HID_377a] = 702,
	[BNXT_ULP_CLASS_HID_2e9e] = 703,
	[BNXT_ULP_CLASS_HID_29fa] = 704,
	[BNXT_ULP_CLASS_HID_14d2] = 705,
	[BNXT_ULP_CLASS_HID_7742] = 706,
	[BNXT_ULP_CLASS_HID_3706] = 707,
	[BNXT_ULP_CLASS_HID_0fe2] = 708,
	[BNXT_ULP_CLASS_HID_1f7e] = 709,
	[BNXT_ULP_CLASS_HID_145a] = 710,
	[BNXT_ULP_CLASS_HID_417e] = 711,
	[BNXT_ULP_CLASS_HID_5e5a] = 712,
	[BNXT_ULP_CLASS_HID_29f6] = 713,
	[BNXT_ULP_CLASS_HID_26d2] = 714,
	[BNXT_ULP_CLASS_HID_2e42] = 715,
	[BNXT_ULP_CLASS_HID_271e] = 716,
	[BNXT_ULP_CLASS_HID_36ba] = 717,
	[BNXT_ULP_CLASS_HID_0f96] = 718,
	[BNXT_ULP_CLASS_HID_1006] = 719,
	[BNXT_ULP_CLASS_HID_7196] = 720,
	[BNXT_ULP_CLASS_HID_4132] = 721,
	[BNXT_ULP_CLASS_HID_5e0e] = 722,
	[BNXT_ULP_CLASS_HID_59fe] = 723,
	[BNXT_ULP_CLASS_HID_511a] = 724,
	[BNXT_ULP_CLASS_HID_1c32] = 725,
	[BNXT_ULP_CLASS_HID_175e] = 726,
	[BNXT_ULP_CLASS_HID_0eb2] = 727,
	[BNXT_ULP_CLASS_HID_09de] = 728,
	[BNXT_ULP_CLASS_HID_5c3a] = 729,
	[BNXT_ULP_CLASS_HID_5766] = 730,
	[BNXT_ULP_CLASS_HID_79fa] = 731,
	[BNXT_ULP_CLASS_HID_7126] = 732,
	[BNXT_ULP_CLASS_HID_3c3e] = 733,
	[BNXT_ULP_CLASS_HID_375a] = 734,
	[BNXT_ULP_CLASS_HID_2ebe] = 735,
	[BNXT_ULP_CLASS_HID_29da] = 736,
	[BNXT_ULP_CLASS_HID_14f2] = 737,
	[BNXT_ULP_CLASS_HID_7762] = 738,
	[BNXT_ULP_CLASS_HID_19e8] = 739,
	[BNXT_ULP_CLASS_HID_110c] = 740,
	[BNXT_ULP_CLASS_HID_4d48] = 741,
	[BNXT_ULP_CLASS_HID_446c] = 742,
	[BNXT_ULP_CLASS_HID_0eac] = 743,
	[BNXT_ULP_CLASS_HID_09c0] = 744,
	[BNXT_ULP_CLASS_HID_1ad0] = 745,
	[BNXT_ULP_CLASS_HID_15f4] = 746,
	[BNXT_ULP_CLASS_HID_39ec] = 747,
	[BNXT_ULP_CLASS_HID_3100] = 748,
	[BNXT_ULP_CLASS_HID_0210] = 749,
	[BNXT_ULP_CLASS_HID_1d34] = 750,
	[BNXT_ULP_CLASS_HID_2ea0] = 751,
	[BNXT_ULP_CLASS_HID_29c4] = 752,
	[BNXT_ULP_CLASS_HID_3ad4] = 753,
	[BNXT_ULP_CLASS_HID_35e8] = 754,
	[BNXT_ULP_CLASS_HID_5d80] = 755,
	[BNXT_ULP_CLASS_HID_54a4] = 756,
	[BNXT_ULP_CLASS_HID_29b4] = 757,
	[BNXT_ULP_CLASS_HID_20c8] = 758,
	[BNXT_ULP_CLASS_HID_7244] = 759,
	[BNXT_ULP_CLASS_HID_4d98] = 760,
	[BNXT_ULP_CLASS_HID_5e68] = 761,
	[BNXT_ULP_CLASS_HID_598c] = 762,
	[BNXT_ULP_CLASS_HID_1248] = 763,
	[BNXT_ULP_CLASS_HID_74d8] = 764,
	[BNXT_ULP_CLASS_HID_49a8] = 765,
	[BNXT_ULP_CLASS_HID_40cc] = 766,
	[BNXT_ULP_CLASS_HID_0b0c] = 767,
	[BNXT_ULP_CLASS_HID_0220] = 768,
	[BNXT_ULP_CLASS_HID_1730] = 769,
	[BNXT_ULP_CLASS_HID_7980] = 770,
	[BNXT_ULP_CLASS_HID_1db0] = 771,
	[BNXT_ULP_CLASS_HID_1494] = 772,
	[BNXT_ULP_CLASS_HID_70d0] = 773,
	[BNXT_ULP_CLASS_HID_4834] = 774,
	[BNXT_ULP_CLASS_HID_3db4] = 775,
	[BNXT_ULP_CLASS_HID_3498] = 776,
	[BNXT_ULP_CLASS_HID_0988] = 777,
	[BNXT_ULP_CLASS_HID_00ec] = 778,
	[BNXT_ULP_CLASS_HID_3f44] = 779,
	[BNXT_ULP_CLASS_HID_36a8] = 780,
	[BNXT_ULP_CLASS_HID_0b58] = 781,
	[BNXT_ULP_CLASS_HID_02bc] = 782,
	[BNXT_ULP_CLASS_HID_5f48] = 783,
	[BNXT_ULP_CLASS_HID_56ac] = 784,
	[BNXT_ULP_CLASS_HID_2b5c] = 785,
	[BNXT_ULP_CLASS_HID_2280] = 786,
	[BNXT_ULP_CLASS_HID_4000] = 787,
	[BNXT_ULP_CLASS_HID_5b64] = 788,
	[BNXT_ULP_CLASS_HID_2c14] = 789,
	[BNXT_ULP_CLASS_HID_2778] = 790,
	[BNXT_ULP_CLASS_HID_18f8] = 791,
	[BNXT_ULP_CLASS_HID_13dc] = 792,
	[BNXT_ULP_CLASS_HID_4c18] = 793,
	[BNXT_ULP_CLASS_HID_477c] = 794,
	[BNXT_ULP_CLASS_HID_1a88] = 795,
	[BNXT_ULP_CLASS_HID_15ec] = 796,
	[BNXT_ULP_CLASS_HID_4e28] = 797,
	[BNXT_ULP_CLASS_HID_490c] = 798,
	[BNXT_ULP_CLASS_HID_3a8c] = 799,
	[BNXT_ULP_CLASS_HID_35f0] = 800,
	[BNXT_ULP_CLASS_HID_06e0] = 801,
	[BNXT_ULP_CLASS_HID_01c4] = 802,
	[BNXT_ULP_CLASS_HID_1a08] = 803,
	[BNXT_ULP_CLASS_HID_12ec] = 804,
	[BNXT_ULP_CLASS_HID_4ea8] = 805,
	[BNXT_ULP_CLASS_HID_478c] = 806,
	[BNXT_ULP_CLASS_HID_0d4c] = 807,
	[BNXT_ULP_CLASS_HID_0a20] = 808,
	[BNXT_ULP_CLASS_HID_1930] = 809,
	[BNXT_ULP_CLASS_HID_1614] = 810,
	[BNXT_ULP_CLASS_HID_3a0c] = 811,
	[BNXT_ULP_CLASS_HID_32e0] = 812,
	[BNXT_ULP_CLASS_HID_01f0] = 813,
	[BNXT_ULP_CLASS_HID_1ed4] = 814,
	[BNXT_ULP_CLASS_HID_2d40] = 815,
	[BNXT_ULP_CLASS_HID_2a24] = 816,
	[BNXT_ULP_CLASS_HID_3934] = 817,
	[BNXT_ULP_CLASS_HID_3608] = 818,
	[BNXT_ULP_CLASS_HID_5e60] = 819,
	[BNXT_ULP_CLASS_HID_5744] = 820,
	[BNXT_ULP_CLASS_HID_2a54] = 821,
	[BNXT_ULP_CLASS_HID_2328] = 822,
	[BNXT_ULP_CLASS_HID_71a4] = 823,
	[BNXT_ULP_CLASS_HID_4e78] = 824,
	[BNXT_ULP_CLASS_HID_5d88] = 825,
	[BNXT_ULP_CLASS_HID_5a6c] = 826,
	[BNXT_ULP_CLASS_HID_11a8] = 827,
	[BNXT_ULP_CLASS_HID_7738] = 828,
	[BNXT_ULP_CLASS_HID_4a48] = 829,
	[BNXT_ULP_CLASS_HID_432c] = 830,
	[BNXT_ULP_CLASS_HID_08ec] = 831,
	[BNXT_ULP_CLASS_HID_01c0] = 832,
	[BNXT_ULP_CLASS_HID_14d0] = 833,
	[BNXT_ULP_CLASS_HID_7a60] = 834,
	[BNXT_ULP_CLASS_HID_1d90] = 835,
	[BNXT_ULP_CLASS_HID_14b4] = 836,
	[BNXT_ULP_CLASS_HID_70f0] = 837,
	[BNXT_ULP_CLASS_HID_4814] = 838,
	[BNXT_ULP_CLASS_HID_3d94] = 839,
	[BNXT_ULP_CLASS_HID_34b8] = 840,
	[BNXT_ULP_CLASS_HID_09a8] = 841,
	[BNXT_ULP_CLASS_HID_00cc] = 842,
	[BNXT_ULP_CLASS_HID_3f64] = 843,
	[BNXT_ULP_CLASS_HID_3688] = 844,
	[BNXT_ULP_CLASS_HID_0b78] = 845,
	[BNXT_ULP_CLASS_HID_029c] = 846,
	[BNXT_ULP_CLASS_HID_5f68] = 847,
	[BNXT_ULP_CLASS_HID_568c] = 848,
	[BNXT_ULP_CLASS_HID_2b7c] = 849,
	[BNXT_ULP_CLASS_HID_22a0] = 850,
	[BNXT_ULP_CLASS_HID_4020] = 851,
	[BNXT_ULP_CLASS_HID_5b44] = 852,
	[BNXT_ULP_CLASS_HID_2c34] = 853,
	[BNXT_ULP_CLASS_HID_2758] = 854,
	[BNXT_ULP_CLASS_HID_18d8] = 855,
	[BNXT_ULP_CLASS_HID_13fc] = 856,
	[BNXT_ULP_CLASS_HID_4c38] = 857,
	[BNXT_ULP_CLASS_HID_475c] = 858,
	[BNXT_ULP_CLASS_HID_1aa8] = 859,
	[BNXT_ULP_CLASS_HID_15cc] = 860,
	[BNXT_ULP_CLASS_HID_4e08] = 861,
	[BNXT_ULP_CLASS_HID_492c] = 862,
	[BNXT_ULP_CLASS_HID_3aac] = 863,
	[BNXT_ULP_CLASS_HID_35d0] = 864,
	[BNXT_ULP_CLASS_HID_06c0] = 865,
	[BNXT_ULP_CLASS_HID_01e4] = 866,
	[BNXT_ULP_CLASS_HID_4d32] = 867,
	[BNXT_ULP_CLASS_HID_54aa] = 868,
	[BNXT_ULP_CLASS_HID_0686] = 869,
	[BNXT_ULP_CLASS_HID_540e] = 870,
	[BNXT_ULP_CLASS_HID_2e3c] = 871,
	[BNXT_ULP_CLASS_HID_3a20] = 872,
	[BNXT_ULP_CLASS_HID_46f0] = 873,
	[BNXT_ULP_CLASS_HID_52e4] = 874,
	[BNXT_ULP_CLASS_HID_55e4] = 875,
	[BNXT_ULP_CLASS_HID_21f8] = 876,
	[BNXT_ULP_CLASS_HID_75e8] = 877,
	[BNXT_ULP_CLASS_HID_41fc] = 878,
	[BNXT_ULP_CLASS_HID_4d12] = 879,
	[BNXT_ULP_CLASS_HID_548a] = 880,
	[BNXT_ULP_CLASS_HID_3356] = 881,
	[BNXT_ULP_CLASS_HID_1ace] = 882,
	[BNXT_ULP_CLASS_HID_1a9a] = 883,
	[BNXT_ULP_CLASS_HID_4d46] = 884,
	[BNXT_ULP_CLASS_HID_2812] = 885,
	[BNXT_ULP_CLASS_HID_338a] = 886,
	[BNXT_ULP_CLASS_HID_06e6] = 887,
	[BNXT_ULP_CLASS_HID_546e] = 888,
	[BNXT_ULP_CLASS_HID_46ee] = 889,
	[BNXT_ULP_CLASS_HID_0d22] = 890,
	[BNXT_ULP_CLASS_HID_26e2] = 891,
	[BNXT_ULP_CLASS_HID_746a] = 892,
	[BNXT_ULP_CLASS_HID_1fa6] = 893,
	[BNXT_ULP_CLASS_HID_2d2e] = 894,
	[BNXT_ULP_CLASS_HID_4ef2] = 895,
	[BNXT_ULP_CLASS_HID_576a] = 896,
	[BNXT_ULP_CLASS_HID_30b6] = 897,
	[BNXT_ULP_CLASS_HID_192e] = 898,
	[BNXT_ULP_CLASS_HID_197a] = 899,
	[BNXT_ULP_CLASS_HID_4ea6] = 900,
	[BNXT_ULP_CLASS_HID_2bf2] = 901,
	[BNXT_ULP_CLASS_HID_306a] = 902,
	[BNXT_ULP_CLASS_HID_06c6] = 903,
	[BNXT_ULP_CLASS_HID_544e] = 904,
	[BNXT_ULP_CLASS_HID_46ce] = 905,
	[BNXT_ULP_CLASS_HID_0d02] = 906,
	[BNXT_ULP_CLASS_HID_26c2] = 907,
	[BNXT_ULP_CLASS_HID_744a] = 908,
	[BNXT_ULP_CLASS_HID_1f86] = 909,
	[BNXT_ULP_CLASS_HID_2d0e] = 910,
	[BNXT_ULP_CLASS_HID_2e1c] = 911,
	[BNXT_ULP_CLASS_HID_3a00] = 912,
	[BNXT_ULP_CLASS_HID_46d0] = 913,
	[BNXT_ULP_CLASS_HID_52c4] = 914,
	[BNXT_ULP_CLASS_HID_4e10] = 915,
	[BNXT_ULP_CLASS_HID_5a04] = 916,
	[BNXT_ULP_CLASS_HID_1f98] = 917,
	[BNXT_ULP_CLASS_HID_72f8] = 918,
	[BNXT_ULP_CLASS_HID_0a78] = 919,
	[BNXT_ULP_CLASS_HID_166c] = 920,
	[BNXT_ULP_CLASS_HID_233c] = 921,
	[BNXT_ULP_CLASS_HID_0f20] = 922,
	[BNXT_ULP_CLASS_HID_2a7c] = 923,
	[BNXT_ULP_CLASS_HID_3660] = 924,
	[BNXT_ULP_CLASS_HID_4330] = 925,
	[BNXT_ULP_CLASS_HID_2f24] = 926,
	[BNXT_ULP_CLASS_HID_5584] = 927,
	[BNXT_ULP_CLASS_HID_2198] = 928,
	[BNXT_ULP_CLASS_HID_7588] = 929,
	[BNXT_ULP_CLASS_HID_419c] = 930,
	[BNXT_ULP_CLASS_HID_7758] = 931,
	[BNXT_ULP_CLASS_HID_43ac] = 932,
	[BNXT_ULP_CLASS_HID_0c10] = 933,
	[BNXT_ULP_CLASS_HID_1864] = 934,
	[BNXT_ULP_CLASS_HID_30c8] = 935,
	[BNXT_ULP_CLASS_HID_1cdc] = 936,
	[BNXT_ULP_CLASS_HID_50cc] = 937,
	[BNXT_ULP_CLASS_HID_3d20] = 938,
	[BNXT_ULP_CLASS_HID_529c] = 939,
	[BNXT_ULP_CLASS_HID_3ef0] = 940,
	[BNXT_ULP_CLASS_HID_72e0] = 941,
	[BNXT_ULP_CLASS_HID_5ef4] = 942,
	[BNXT_ULP_CLASS_HID_2dfc] = 943,
	[BNXT_ULP_CLASS_HID_39e0] = 944,
	[BNXT_ULP_CLASS_HID_4530] = 945,
	[BNXT_ULP_CLASS_HID_5124] = 946,
	[BNXT_ULP_CLASS_HID_4df0] = 947,
	[BNXT_ULP_CLASS_HID_59e4] = 948,
	[BNXT_ULP_CLASS_HID_1c78] = 949,
	[BNXT_ULP_CLASS_HID_7118] = 950,
	[BNXT_ULP_CLASS_HID_0998] = 951,
	[BNXT_ULP_CLASS_HID_158c] = 952,
	[BNXT_ULP_CLASS_HID_20dc] = 953,
	[BNXT_ULP_CLASS_HID_0cc0] = 954,
	[BNXT_ULP_CLASS_HID_299c] = 955,
	[BNXT_ULP_CLASS_HID_3580] = 956,
	[BNXT_ULP_CLASS_HID_40d0] = 957,
	[BNXT_ULP_CLASS_HID_2cc4] = 958,
	[BNXT_ULP_CLASS_HID_55a4] = 959,
	[BNXT_ULP_CLASS_HID_21b8] = 960,
	[BNXT_ULP_CLASS_HID_75a8] = 961,
	[BNXT_ULP_CLASS_HID_41bc] = 962,
	[BNXT_ULP_CLASS_HID_7778] = 963,
	[BNXT_ULP_CLASS_HID_438c] = 964,
	[BNXT_ULP_CLASS_HID_0c30] = 965,
	[BNXT_ULP_CLASS_HID_1844] = 966,
	[BNXT_ULP_CLASS_HID_30e8] = 967,
	[BNXT_ULP_CLASS_HID_1cfc] = 968,
	[BNXT_ULP_CLASS_HID_50ec] = 969,
	[BNXT_ULP_CLASS_HID_3d00] = 970,
	[BNXT_ULP_CLASS_HID_52bc] = 971,
	[BNXT_ULP_CLASS_HID_3ed0] = 972,
	[BNXT_ULP_CLASS_HID_72c0] = 973,
	[BNXT_ULP_CLASS_HID_5ed4] = 974,
	[BNXT_ULP_CLASS_HID_3866] = 975,
	[BNXT_ULP_CLASS_HID_381e] = 976,
	[BNXT_ULP_CLASS_HID_3860] = 977,
	[BNXT_ULP_CLASS_HID_0454] = 978,
	[BNXT_ULP_CLASS_HID_3818] = 979,
	[BNXT_ULP_CLASS_HID_042c] = 980,
	[BNXT_ULP_CLASS_HID_3846] = 981,
	[BNXT_ULP_CLASS_HID_387e] = 982,
	[BNXT_ULP_CLASS_HID_3ba6] = 983,
	[BNXT_ULP_CLASS_HID_385e] = 984,
	[BNXT_ULP_CLASS_HID_3840] = 985,
	[BNXT_ULP_CLASS_HID_0474] = 986,
	[BNXT_ULP_CLASS_HID_3878] = 987,
	[BNXT_ULP_CLASS_HID_044c] = 988,
	[BNXT_ULP_CLASS_HID_3ba0] = 989,
	[BNXT_ULP_CLASS_HID_0794] = 990,
	[BNXT_ULP_CLASS_HID_3858] = 991,
	[BNXT_ULP_CLASS_HID_046c] = 992
};

/* Array for the proto matcher list */
struct bnxt_ulp_class_match_info ulp_class_match_list[] = {
	[1] = {
	.class_hid = BNXT_ULP_CLASS_HID_55dd,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[2] = {
	.class_hid = BNXT_ULP_CLASS_HID_1df1,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 4104UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[3] = {
	.class_hid = BNXT_ULP_CLASS_HID_3e55,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[4] = {
	.class_hid = BNXT_ULP_CLASS_HID_0649,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 6152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[5] = {
	.class_hid = BNXT_ULP_CLASS_HID_1011,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[6] = {
	.class_hid = BNXT_ULP_CLASS_HID_40e9,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 16392UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[7] = {
	.class_hid = BNXT_ULP_CLASS_HID_3e99,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[8] = {
	.class_hid = BNXT_ULP_CLASS_HID_06ad,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 24584UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[9] = {
	.class_hid = BNXT_ULP_CLASS_HID_38c7,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[10] = {
	.class_hid = BNXT_ULP_CLASS_HID_00fb,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32776UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[11] = {
	.class_hid = BNXT_ULP_CLASS_HID_24d3,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[12] = {
	.class_hid = BNXT_ULP_CLASS_HID_559b,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32840UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[13] = {
	.class_hid = BNXT_ULP_CLASS_HID_5003,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[14] = {
	.class_hid = BNXT_ULP_CLASS_HID_1837,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49160UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[15] = {
	.class_hid = BNXT_ULP_CLASS_HID_3bef,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[16] = {
	.class_hid = BNXT_ULP_CLASS_HID_0403,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49224UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[17] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d3f,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[18] = {
	.class_hid = BNXT_ULP_CLASS_HID_0543,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131080UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[19] = {
	.class_hid = BNXT_ULP_CLASS_HID_292b,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[20] = {
	.class_hid = BNXT_ULP_CLASS_HID_59e3,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131144UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[21] = {
	.class_hid = BNXT_ULP_CLASS_HID_5d3b,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[22] = {
	.class_hid = BNXT_ULP_CLASS_HID_254f,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196616UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[23] = {
	.class_hid = BNXT_ULP_CLASS_HID_4917,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[24] = {
	.class_hid = BNXT_ULP_CLASS_HID_113b,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196680UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[25] = {
	.class_hid = BNXT_ULP_CLASS_HID_55fd,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[26] = {
	.class_hid = BNXT_ULP_CLASS_HID_1dd1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 4104UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[27] = {
	.class_hid = BNXT_ULP_CLASS_HID_3e75,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[28] = {
	.class_hid = BNXT_ULP_CLASS_HID_0669,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 6152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[29] = {
	.class_hid = BNXT_ULP_CLASS_HID_1ba1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 12288UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[30] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c69,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 12296UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[31] = {
	.class_hid = BNXT_ULP_CLASS_HID_0439,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 14336UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[32] = {
	.class_hid = BNXT_ULP_CLASS_HID_34e1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 14344UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[33] = {
	.class_hid = BNXT_ULP_CLASS_HID_0465,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 20480UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[34] = {
	.class_hid = BNXT_ULP_CLASS_HID_352d,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 20488UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[35] = {
	.class_hid = BNXT_ULP_CLASS_HID_55b1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 22528UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[36] = {
	.class_hid = BNXT_ULP_CLASS_HID_1da5,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 22536UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[37] = {
	.class_hid = BNXT_ULP_CLASS_HID_32fd,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 28672UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[38] = {
	.class_hid = BNXT_ULP_CLASS_HID_63a5,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 28680UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[39] = {
	.class_hid = BNXT_ULP_CLASS_HID_1b75,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 30720UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[40] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c3d,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 30728UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[41] = {
	.class_hid = BNXT_ULP_CLASS_HID_1031,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[42] = {
	.class_hid = BNXT_ULP_CLASS_HID_40c9,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 16392UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[43] = {
	.class_hid = BNXT_ULP_CLASS_HID_3eb9,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[44] = {
	.class_hid = BNXT_ULP_CLASS_HID_068d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 24584UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[45] = {
	.class_hid = BNXT_ULP_CLASS_HID_5039,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[46] = {
	.class_hid = BNXT_ULP_CLASS_HID_180d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 49160UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[47] = {
	.class_hid = BNXT_ULP_CLASS_HID_15fd,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 57344UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[48] = {
	.class_hid = BNXT_ULP_CLASS_HID_46b5,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 57352UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[49] = {
	.class_hid = BNXT_ULP_CLASS_HID_303d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 81920UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[50] = {
	.class_hid = BNXT_ULP_CLASS_HID_60f5,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 81928UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[51] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ea5,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 90112UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[52] = {
	.class_hid = BNXT_ULP_CLASS_HID_2689,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 90120UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[53] = {
	.class_hid = BNXT_ULP_CLASS_HID_0771,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[54] = {
	.class_hid = BNXT_ULP_CLASS_HID_3809,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 114696UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[55] = {
	.class_hid = BNXT_ULP_CLASS_HID_35f9,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 122880UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[56] = {
	.class_hid = BNXT_ULP_CLASS_HID_66b1,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 122888UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[57] = {
	.class_hid = BNXT_ULP_CLASS_HID_559d,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[58] = {
	.class_hid = BNXT_ULP_CLASS_HID_1db1,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 4104UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[59] = {
	.class_hid = BNXT_ULP_CLASS_HID_3e15,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[60] = {
	.class_hid = BNXT_ULP_CLASS_HID_0609,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 6152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[61] = {
	.class_hid = BNXT_ULP_CLASS_HID_1bc1,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 12288UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[62] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c09,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 12296UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[63] = {
	.class_hid = BNXT_ULP_CLASS_HID_0459,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 14336UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[64] = {
	.class_hid = BNXT_ULP_CLASS_HID_3481,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 14344UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[65] = {
	.class_hid = BNXT_ULP_CLASS_HID_0405,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 20480UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[66] = {
	.class_hid = BNXT_ULP_CLASS_HID_354d,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 20488UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[67] = {
	.class_hid = BNXT_ULP_CLASS_HID_55d1,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 22528UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[68] = {
	.class_hid = BNXT_ULP_CLASS_HID_1dc5,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 22536UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[69] = {
	.class_hid = BNXT_ULP_CLASS_HID_329d,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 28672UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[70] = {
	.class_hid = BNXT_ULP_CLASS_HID_63c5,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 28680UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[71] = {
	.class_hid = BNXT_ULP_CLASS_HID_1b15,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 30720UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[72] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c5d,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 30728UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[73] = {
	.class_hid = BNXT_ULP_CLASS_HID_1051,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[74] = {
	.class_hid = BNXT_ULP_CLASS_HID_40a9,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 16392UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[75] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ed9,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[76] = {
	.class_hid = BNXT_ULP_CLASS_HID_06ed,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 24584UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[77] = {
	.class_hid = BNXT_ULP_CLASS_HID_5059,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[78] = {
	.class_hid = BNXT_ULP_CLASS_HID_186d,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 49160UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[79] = {
	.class_hid = BNXT_ULP_CLASS_HID_159d,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 57344UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[80] = {
	.class_hid = BNXT_ULP_CLASS_HID_46d5,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 57352UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[81] = {
	.class_hid = BNXT_ULP_CLASS_HID_305d,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 81920UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[82] = {
	.class_hid = BNXT_ULP_CLASS_HID_6095,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 81928UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[83] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ec5,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 90112UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[84] = {
	.class_hid = BNXT_ULP_CLASS_HID_26e9,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 90120UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[85] = {
	.class_hid = BNXT_ULP_CLASS_HID_0711,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[86] = {
	.class_hid = BNXT_ULP_CLASS_HID_3869,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 114696UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[87] = {
	.class_hid = BNXT_ULP_CLASS_HID_3599,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 122880UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[88] = {
	.class_hid = BNXT_ULP_CLASS_HID_66d1,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 122888UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[89] = {
	.class_hid = BNXT_ULP_CLASS_HID_38e7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[90] = {
	.class_hid = BNXT_ULP_CLASS_HID_00db,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32776UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[91] = {
	.class_hid = BNXT_ULP_CLASS_HID_24f3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[92] = {
	.class_hid = BNXT_ULP_CLASS_HID_55bb,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32840UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[93] = {
	.class_hid = BNXT_ULP_CLASS_HID_5023,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[94] = {
	.class_hid = BNXT_ULP_CLASS_HID_1817,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49160UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[95] = {
	.class_hid = BNXT_ULP_CLASS_HID_3bcf,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[96] = {
	.class_hid = BNXT_ULP_CLASS_HID_0423,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49224UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[97] = {
	.class_hid = BNXT_ULP_CLASS_HID_58e3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98304UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[98] = {
	.class_hid = BNXT_ULP_CLASS_HID_20d7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98312UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[99] = {
	.class_hid = BNXT_ULP_CLASS_HID_448f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98368UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[100] = {
	.class_hid = BNXT_ULP_CLASS_HID_0ce3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98376UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[101] = {
	.class_hid = BNXT_ULP_CLASS_HID_076b,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[102] = {
	.class_hid = BNXT_ULP_CLASS_HID_3813,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114696UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[103] = {
	.class_hid = BNXT_ULP_CLASS_HID_5bcb,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114752UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[104] = {
	.class_hid = BNXT_ULP_CLASS_HID_243f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114760UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[105] = {
	.class_hid = BNXT_ULP_CLASS_HID_144b,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163840UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[106] = {
	.class_hid = BNXT_ULP_CLASS_HID_4573,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163848UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[107] = {
	.class_hid = BNXT_ULP_CLASS_HID_0057,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163904UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[108] = {
	.class_hid = BNXT_ULP_CLASS_HID_311f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163912UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[109] = {
	.class_hid = BNXT_ULP_CLASS_HID_2b87,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180224UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[110] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c4f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180232UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[111] = {
	.class_hid = BNXT_ULP_CLASS_HID_1793,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180288UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[112] = {
	.class_hid = BNXT_ULP_CLASS_HID_485b,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180296UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[113] = {
	.class_hid = BNXT_ULP_CLASS_HID_3447,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229376UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[114] = {
	.class_hid = BNXT_ULP_CLASS_HID_650f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229384UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[115] = {
	.class_hid = BNXT_ULP_CLASS_HID_2053,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229440UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[116] = {
	.class_hid = BNXT_ULP_CLASS_HID_511b,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229448UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[117] = {
	.class_hid = BNXT_ULP_CLASS_HID_4b83,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245760UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[118] = {
	.class_hid = BNXT_ULP_CLASS_HID_13f7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245768UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[119] = {
	.class_hid = BNXT_ULP_CLASS_HID_37af,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245824UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[120] = {
	.class_hid = BNXT_ULP_CLASS_HID_6857,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245832UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[121] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d1f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[122] = {
	.class_hid = BNXT_ULP_CLASS_HID_0563,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131080UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[123] = {
	.class_hid = BNXT_ULP_CLASS_HID_290b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[124] = {
	.class_hid = BNXT_ULP_CLASS_HID_59c3,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131144UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[125] = {
	.class_hid = BNXT_ULP_CLASS_HID_5d1b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[126] = {
	.class_hid = BNXT_ULP_CLASS_HID_256f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196616UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[127] = {
	.class_hid = BNXT_ULP_CLASS_HID_4937,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[128] = {
	.class_hid = BNXT_ULP_CLASS_HID_111b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196680UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[129] = {
	.class_hid = BNXT_ULP_CLASS_HID_5f4b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393216UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[130] = {
	.class_hid = BNXT_ULP_CLASS_HID_275f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393224UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[131] = {
	.class_hid = BNXT_ULP_CLASS_HID_4b67,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393280UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[132] = {
	.class_hid = BNXT_ULP_CLASS_HID_134b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393288UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[133] = {
	.class_hid = BNXT_ULP_CLASS_HID_1683,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458752UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[134] = {
	.class_hid = BNXT_ULP_CLASS_HID_475b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458760UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[135] = {
	.class_hid = BNXT_ULP_CLASS_HID_02bf,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458816UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[136] = {
	.class_hid = BNXT_ULP_CLASS_HID_3377,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458824UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[137] = {
	.class_hid = BNXT_ULP_CLASS_HID_19db,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655360UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[138] = {
	.class_hid = BNXT_ULP_CLASS_HID_4a93,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655368UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[139] = {
	.class_hid = BNXT_ULP_CLASS_HID_05f7,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655424UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[140] = {
	.class_hid = BNXT_ULP_CLASS_HID_368f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655432UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[141] = {
	.class_hid = BNXT_ULP_CLASS_HID_39c7,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720896UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[142] = {
	.class_hid = BNXT_ULP_CLASS_HID_022b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720904UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[143] = {
	.class_hid = BNXT_ULP_CLASS_HID_25f3,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720960UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[144] = {
	.class_hid = BNXT_ULP_CLASS_HID_568b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720968UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[145] = {
	.class_hid = BNXT_ULP_CLASS_HID_3c37,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917504UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[146] = {
	.class_hid = BNXT_ULP_CLASS_HID_041b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917512UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[147] = {
	.class_hid = BNXT_ULP_CLASS_HID_2823,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917568UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[148] = {
	.class_hid = BNXT_ULP_CLASS_HID_58fb,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917576UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[149] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c33,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983040UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[150] = {
	.class_hid = BNXT_ULP_CLASS_HID_2407,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983048UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[151] = {
	.class_hid = BNXT_ULP_CLASS_HID_482f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983104UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[152] = {
	.class_hid = BNXT_ULP_CLASS_HID_1033,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983112UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[153] = {
	.class_hid = BNXT_ULP_CLASS_HID_3887,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[154] = {
	.class_hid = BNXT_ULP_CLASS_HID_00bb,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32776UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[155] = {
	.class_hid = BNXT_ULP_CLASS_HID_2493,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[156] = {
	.class_hid = BNXT_ULP_CLASS_HID_55db,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32840UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[157] = {
	.class_hid = BNXT_ULP_CLASS_HID_5043,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[158] = {
	.class_hid = BNXT_ULP_CLASS_HID_1877,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49160UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[159] = {
	.class_hid = BNXT_ULP_CLASS_HID_3baf,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[160] = {
	.class_hid = BNXT_ULP_CLASS_HID_0443,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49224UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[161] = {
	.class_hid = BNXT_ULP_CLASS_HID_5883,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98304UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[162] = {
	.class_hid = BNXT_ULP_CLASS_HID_20b7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98312UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[163] = {
	.class_hid = BNXT_ULP_CLASS_HID_44ef,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98368UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[164] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c83,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98376UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[165] = {
	.class_hid = BNXT_ULP_CLASS_HID_070b,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[166] = {
	.class_hid = BNXT_ULP_CLASS_HID_3873,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114696UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[167] = {
	.class_hid = BNXT_ULP_CLASS_HID_5bab,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114752UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[168] = {
	.class_hid = BNXT_ULP_CLASS_HID_245f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114760UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[169] = {
	.class_hid = BNXT_ULP_CLASS_HID_142b,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163840UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[170] = {
	.class_hid = BNXT_ULP_CLASS_HID_4513,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163848UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[171] = {
	.class_hid = BNXT_ULP_CLASS_HID_0037,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163904UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[172] = {
	.class_hid = BNXT_ULP_CLASS_HID_317f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163912UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[173] = {
	.class_hid = BNXT_ULP_CLASS_HID_2be7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180224UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[174] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c2f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180232UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[175] = {
	.class_hid = BNXT_ULP_CLASS_HID_17f3,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180288UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[176] = {
	.class_hid = BNXT_ULP_CLASS_HID_483b,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180296UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[177] = {
	.class_hid = BNXT_ULP_CLASS_HID_3427,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229376UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[178] = {
	.class_hid = BNXT_ULP_CLASS_HID_656f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229384UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[179] = {
	.class_hid = BNXT_ULP_CLASS_HID_2033,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229440UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[180] = {
	.class_hid = BNXT_ULP_CLASS_HID_517b,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229448UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[181] = {
	.class_hid = BNXT_ULP_CLASS_HID_4be3,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245760UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[182] = {
	.class_hid = BNXT_ULP_CLASS_HID_1397,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245768UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[183] = {
	.class_hid = BNXT_ULP_CLASS_HID_37cf,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245824UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[184] = {
	.class_hid = BNXT_ULP_CLASS_HID_6837,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245832UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[185] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d7f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[186] = {
	.class_hid = BNXT_ULP_CLASS_HID_0503,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131080UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[187] = {
	.class_hid = BNXT_ULP_CLASS_HID_296b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[188] = {
	.class_hid = BNXT_ULP_CLASS_HID_59a3,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131144UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[189] = {
	.class_hid = BNXT_ULP_CLASS_HID_5d7b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[190] = {
	.class_hid = BNXT_ULP_CLASS_HID_250f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196616UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[191] = {
	.class_hid = BNXT_ULP_CLASS_HID_4957,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[192] = {
	.class_hid = BNXT_ULP_CLASS_HID_117b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196680UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[193] = {
	.class_hid = BNXT_ULP_CLASS_HID_5f2b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393216UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[194] = {
	.class_hid = BNXT_ULP_CLASS_HID_273f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393224UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[195] = {
	.class_hid = BNXT_ULP_CLASS_HID_4b07,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393280UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[196] = {
	.class_hid = BNXT_ULP_CLASS_HID_132b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393288UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[197] = {
	.class_hid = BNXT_ULP_CLASS_HID_16e3,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458752UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[198] = {
	.class_hid = BNXT_ULP_CLASS_HID_473b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458760UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[199] = {
	.class_hid = BNXT_ULP_CLASS_HID_02df,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458816UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[200] = {
	.class_hid = BNXT_ULP_CLASS_HID_3317,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458824UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[201] = {
	.class_hid = BNXT_ULP_CLASS_HID_19bb,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655360UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[202] = {
	.class_hid = BNXT_ULP_CLASS_HID_4af3,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655368UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[203] = {
	.class_hid = BNXT_ULP_CLASS_HID_0597,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655424UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[204] = {
	.class_hid = BNXT_ULP_CLASS_HID_36ef,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655432UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[205] = {
	.class_hid = BNXT_ULP_CLASS_HID_39a7,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720896UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[206] = {
	.class_hid = BNXT_ULP_CLASS_HID_024b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720904UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[207] = {
	.class_hid = BNXT_ULP_CLASS_HID_2593,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720960UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[208] = {
	.class_hid = BNXT_ULP_CLASS_HID_56eb,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720968UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[209] = {
	.class_hid = BNXT_ULP_CLASS_HID_3c57,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917504UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[210] = {
	.class_hid = BNXT_ULP_CLASS_HID_047b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917512UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[211] = {
	.class_hid = BNXT_ULP_CLASS_HID_2843,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917568UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[212] = {
	.class_hid = BNXT_ULP_CLASS_HID_589b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917576UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[213] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c53,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983040UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[214] = {
	.class_hid = BNXT_ULP_CLASS_HID_2467,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983048UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[215] = {
	.class_hid = BNXT_ULP_CLASS_HID_484f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983104UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[216] = {
	.class_hid = BNXT_ULP_CLASS_HID_1053,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983112UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[217] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ce1,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[218] = {
	.class_hid = BNXT_ULP_CLASS_HID_4579,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[219] = {
	.class_hid = BNXT_ULP_CLASS_HID_1735,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[220] = {
	.class_hid = BNXT_ULP_CLASS_HID_45bd,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[221] = {
	.class_hid = BNXT_ULP_CLASS_HID_3feb,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[222] = {
	.class_hid = BNXT_ULP_CLASS_HID_2bf7,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[223] = {
	.class_hid = BNXT_ULP_CLASS_HID_5727,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[224] = {
	.class_hid = BNXT_ULP_CLASS_HID_4333,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[225] = {
	.class_hid = BNXT_ULP_CLASS_HID_4453,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[226] = {
	.class_hid = BNXT_ULP_CLASS_HID_304f,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[227] = {
	.class_hid = BNXT_ULP_CLASS_HID_645f,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[228] = {
	.class_hid = BNXT_ULP_CLASS_HID_504b,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[229] = {
	.class_hid = BNXT_ULP_CLASS_HID_5cc1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[230] = {
	.class_hid = BNXT_ULP_CLASS_HID_4559,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[231] = {
	.class_hid = BNXT_ULP_CLASS_HID_2285,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 12288UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[232] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b1d,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 14336UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[233] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b49,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 20480UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[234] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c95,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 22528UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[235] = {
	.class_hid = BNXT_ULP_CLASS_HID_39c1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 28672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[236] = {
	.class_hid = BNXT_ULP_CLASS_HID_2259,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 30720UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[237] = {
	.class_hid = BNXT_ULP_CLASS_HID_1715,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[238] = {
	.class_hid = BNXT_ULP_CLASS_HID_459d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[239] = {
	.class_hid = BNXT_ULP_CLASS_HID_571d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[240] = {
	.class_hid = BNXT_ULP_CLASS_HID_1cd1,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 57344UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[241] = {
	.class_hid = BNXT_ULP_CLASS_HID_3711,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 81920UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[242] = {
	.class_hid = BNXT_ULP_CLASS_HID_6599,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 90112UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[243] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e55,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[244] = {
	.class_hid = BNXT_ULP_CLASS_HID_3cdd,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 122880UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[245] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ca1,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[246] = {
	.class_hid = BNXT_ULP_CLASS_HID_4539,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[247] = {
	.class_hid = BNXT_ULP_CLASS_HID_22e5,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 12288UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[248] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b7d,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 14336UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[249] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b29,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 20480UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[250] = {
	.class_hid = BNXT_ULP_CLASS_HID_5cf5,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 22528UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[251] = {
	.class_hid = BNXT_ULP_CLASS_HID_39a1,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 28672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[252] = {
	.class_hid = BNXT_ULP_CLASS_HID_2239,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 30720UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[253] = {
	.class_hid = BNXT_ULP_CLASS_HID_1775,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[254] = {
	.class_hid = BNXT_ULP_CLASS_HID_45fd,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[255] = {
	.class_hid = BNXT_ULP_CLASS_HID_577d,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[256] = {
	.class_hid = BNXT_ULP_CLASS_HID_1cb1,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 57344UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[257] = {
	.class_hid = BNXT_ULP_CLASS_HID_3771,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 81920UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[258] = {
	.class_hid = BNXT_ULP_CLASS_HID_65f9,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 90112UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[259] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e35,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[260] = {
	.class_hid = BNXT_ULP_CLASS_HID_3cbd,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 122880UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[261] = {
	.class_hid = BNXT_ULP_CLASS_HID_3fcb,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[262] = {
	.class_hid = BNXT_ULP_CLASS_HID_2bd7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[263] = {
	.class_hid = BNXT_ULP_CLASS_HID_5707,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[264] = {
	.class_hid = BNXT_ULP_CLASS_HID_4313,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[265] = {
	.class_hid = BNXT_ULP_CLASS_HID_5fc7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98304UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[266] = {
	.class_hid = BNXT_ULP_CLASS_HID_4bd3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98368UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[267] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e4f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[268] = {
	.class_hid = BNXT_ULP_CLASS_HID_632f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114752UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[269] = {
	.class_hid = BNXT_ULP_CLASS_HID_1baf,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163840UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[270] = {
	.class_hid = BNXT_ULP_CLASS_HID_07bb,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163904UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[271] = {
	.class_hid = BNXT_ULP_CLASS_HID_32eb,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180224UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[272] = {
	.class_hid = BNXT_ULP_CLASS_HID_1ef7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180288UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[273] = {
	.class_hid = BNXT_ULP_CLASS_HID_3bab,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229376UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[274] = {
	.class_hid = BNXT_ULP_CLASS_HID_27b7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229440UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[275] = {
	.class_hid = BNXT_ULP_CLASS_HID_52e7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245760UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[276] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ef3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245824UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[277] = {
	.class_hid = BNXT_ULP_CLASS_HID_4473,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[278] = {
	.class_hid = BNXT_ULP_CLASS_HID_306f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[279] = {
	.class_hid = BNXT_ULP_CLASS_HID_647f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[280] = {
	.class_hid = BNXT_ULP_CLASS_HID_506b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[281] = {
	.class_hid = BNXT_ULP_CLASS_HID_66af,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[282] = {
	.class_hid = BNXT_ULP_CLASS_HID_525b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393280UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[283] = {
	.class_hid = BNXT_ULP_CLASS_HID_1de7,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458752UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[284] = {
	.class_hid = BNXT_ULP_CLASS_HID_0993,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458816UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[285] = {
	.class_hid = BNXT_ULP_CLASS_HID_213f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655360UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[286] = {
	.class_hid = BNXT_ULP_CLASS_HID_0d2b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655424UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[287] = {
	.class_hid = BNXT_ULP_CLASS_HID_413b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720896UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[288] = {
	.class_hid = BNXT_ULP_CLASS_HID_2cd7,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720960UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[289] = {
	.class_hid = BNXT_ULP_CLASS_HID_436b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917504UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[290] = {
	.class_hid = BNXT_ULP_CLASS_HID_2f07,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917568UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[291] = {
	.class_hid = BNXT_ULP_CLASS_HID_6317,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983040UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[292] = {
	.class_hid = BNXT_ULP_CLASS_HID_4f03,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983104UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[293] = {
	.class_hid = BNXT_ULP_CLASS_HID_3fab,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[294] = {
	.class_hid = BNXT_ULP_CLASS_HID_2bb7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[295] = {
	.class_hid = BNXT_ULP_CLASS_HID_5767,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[296] = {
	.class_hid = BNXT_ULP_CLASS_HID_4373,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[297] = {
	.class_hid = BNXT_ULP_CLASS_HID_5fa7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98304UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[298] = {
	.class_hid = BNXT_ULP_CLASS_HID_4bb3,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98368UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[299] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e2f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[300] = {
	.class_hid = BNXT_ULP_CLASS_HID_634f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114752UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[301] = {
	.class_hid = BNXT_ULP_CLASS_HID_1bcf,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163840UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[302] = {
	.class_hid = BNXT_ULP_CLASS_HID_07db,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163904UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[303] = {
	.class_hid = BNXT_ULP_CLASS_HID_328b,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180224UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[304] = {
	.class_hid = BNXT_ULP_CLASS_HID_1e97,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180288UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[305] = {
	.class_hid = BNXT_ULP_CLASS_HID_3bcb,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229376UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[306] = {
	.class_hid = BNXT_ULP_CLASS_HID_27d7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229440UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[307] = {
	.class_hid = BNXT_ULP_CLASS_HID_5287,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245760UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[308] = {
	.class_hid = BNXT_ULP_CLASS_HID_3e93,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245824UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[309] = {
	.class_hid = BNXT_ULP_CLASS_HID_4413,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[310] = {
	.class_hid = BNXT_ULP_CLASS_HID_300f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[311] = {
	.class_hid = BNXT_ULP_CLASS_HID_641f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[312] = {
	.class_hid = BNXT_ULP_CLASS_HID_500b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[313] = {
	.class_hid = BNXT_ULP_CLASS_HID_66cf,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[314] = {
	.class_hid = BNXT_ULP_CLASS_HID_523b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393280UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[315] = {
	.class_hid = BNXT_ULP_CLASS_HID_1d87,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458752UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[316] = {
	.class_hid = BNXT_ULP_CLASS_HID_09f3,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458816UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[317] = {
	.class_hid = BNXT_ULP_CLASS_HID_215f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655360UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[318] = {
	.class_hid = BNXT_ULP_CLASS_HID_0d4b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655424UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[319] = {
	.class_hid = BNXT_ULP_CLASS_HID_415b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720896UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[320] = {
	.class_hid = BNXT_ULP_CLASS_HID_2cb7,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720960UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[321] = {
	.class_hid = BNXT_ULP_CLASS_HID_430b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917504UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[322] = {
	.class_hid = BNXT_ULP_CLASS_HID_2f67,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917568UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[323] = {
	.class_hid = BNXT_ULP_CLASS_HID_6377,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983040UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[324] = {
	.class_hid = BNXT_ULP_CLASS_HID_4f63,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983104UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[325] = {
	.class_hid = BNXT_ULP_CLASS_HID_29b5,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_SMAC }
	},
	[326] = {
	.class_hid = BNXT_ULP_CLASS_HID_29ad,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_SMAC }
	},
	[327] = {
	.class_hid = BNXT_ULP_CLASS_HID_29b7,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC }
	},
	[328] = {
	.class_hid = BNXT_ULP_CLASS_HID_1583,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 72UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID }
	},
	[329] = {
	.class_hid = BNXT_ULP_CLASS_HID_29af,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC }
	},
	[330] = {
	.class_hid = BNXT_ULP_CLASS_HID_159b,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 72UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID }
	},
	[331] = {
	.class_hid = BNXT_ULP_CLASS_HID_2995,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC }
	},
	[332] = {
	.class_hid = BNXT_ULP_CLASS_HID_298d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC }
	},
	[333] = {
	.class_hid = BNXT_ULP_CLASS_HID_29f5,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC }
	},
	[334] = {
	.class_hid = BNXT_ULP_CLASS_HID_29ed,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC }
	},
	[335] = {
	.class_hid = BNXT_ULP_CLASS_HID_2997,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC }
	},
	[336] = {
	.class_hid = BNXT_ULP_CLASS_HID_15a3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 72UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID }
	},
	[337] = {
	.class_hid = BNXT_ULP_CLASS_HID_298f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC }
	},
	[338] = {
	.class_hid = BNXT_ULP_CLASS_HID_15bb,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 72UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID }
	},
	[339] = {
	.class_hid = BNXT_ULP_CLASS_HID_29f7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC }
	},
	[340] = {
	.class_hid = BNXT_ULP_CLASS_HID_15c3,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 72UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID }
	},
	[341] = {
	.class_hid = BNXT_ULP_CLASS_HID_29ef,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 8UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC }
	},
	[342] = {
	.class_hid = BNXT_ULP_CLASS_HID_15db,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 72UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID }
	},
	[343] = {
	.class_hid = BNXT_ULP_CLASS_HID_1151,
	.class_tid = 1,
	.hdr_sig_id = 12,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 3,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_12_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_12_BITMASK_O_IPV4_DST_ADDR }
	},
	[344] = {
	.class_hid = BNXT_ULP_CLASS_HID_315d,
	.class_tid = 1,
	.hdr_sig_id = 12,
	.flow_sig_id = 81920UL,
	.flow_pattern_id = 3,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_12_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_12_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_12_BITMASK_O_UDP_DST_PORT }
	},
	[345] = {
	.class_hid = BNXT_ULP_CLASS_HID_3612,
	.class_tid = 2,
	.hdr_sig_id = 0,
	.flow_sig_id = 81920UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_F1 |
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_0_BITMASK_O_UDP_DST_PORT }
	},
	[346] = {
	.class_hid = BNXT_ULP_CLASS_HID_66da,
	.class_tid = 2,
	.hdr_sig_id = 0,
	.flow_sig_id = 81928UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_F1 |
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_0_BITMASK_O_UDP_DST_PORT }
	},
	[347] = {
	.class_hid = BNXT_ULP_CLASS_HID_e082,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 1313792UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC }
	},
	[348] = {
	.class_hid = BNXT_ULP_CLASS_HID_ab46,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 1321984UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC }
	},
	[349] = {
	.class_hid = BNXT_ULP_CLASS_HID_c82a,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 3410944UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_SMAC }
	},
	[350] = {
	.class_hid = BNXT_ULP_CLASS_HID_f9a2,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 3419136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_SMAC }
	},
	[351] = {
	.class_hid = BNXT_ULP_CLASS_HID_d8ce,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 538184704UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_SRC_ADDR }
	},
	[352] = {
	.class_hid = BNXT_ULP_CLASS_HID_a2d2,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 538192896UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_SRC_ADDR }
	},
	[353] = {
	.class_hid = BNXT_ULP_CLASS_HID_c076,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 540281856UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_SRC_ADDR }
	},
	[354] = {
	.class_hid = BNXT_ULP_CLASS_HID_f1ee,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 540290048UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_SRC_ADDR }
	},
	[355] = {
	.class_hid = BNXT_ULP_CLASS_HID_a96e,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 1075055616UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_DST_ADDR }
	},
	[356] = {
	.class_hid = BNXT_ULP_CLASS_HID_dae6,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 1075063808UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_DST_ADDR }
	},
	[357] = {
	.class_hid = BNXT_ULP_CLASS_HID_c7aa,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 1077152768UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_DST_ADDR }
	},
	[358] = {
	.class_hid = BNXT_ULP_CLASS_HID_c26e,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 1077160960UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_DST_ADDR }
	},
	[359] = {
	.class_hid = BNXT_ULP_CLASS_HID_a0fa,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 1611926528UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_DST_ADDR }
	},
	[360] = {
	.class_hid = BNXT_ULP_CLASS_HID_d272,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 1611934720UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_DST_ADDR }
	},
	[361] = {
	.class_hid = BNXT_ULP_CLASS_HID_fff6,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 1614023680UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_DST_ADDR }
	},
	[362] = {
	.class_hid = BNXT_ULP_CLASS_HID_e16e,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 1614031872UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_1_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_I_IPV6_DST_ADDR }
	},
	[363] = {
	.class_hid = BNXT_ULP_CLASS_HID_e165,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 1313792UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC }
	},
	[364] = {
	.class_hid = BNXT_ULP_CLASS_HID_aaa1,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 1321984UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC }
	},
	[365] = {
	.class_hid = BNXT_ULP_CLASS_HID_c9cd,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 3410944UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_SMAC }
	},
	[366] = {
	.class_hid = BNXT_ULP_CLASS_HID_f845,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 3419136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_SMAC }
	},
	[367] = {
	.class_hid = BNXT_ULP_CLASS_HID_90f9,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 2148797440UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_SRC_ADDR }
	},
	[368] = {
	.class_hid = BNXT_ULP_CLASS_HID_c371,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 2148805632UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_SRC_ADDR }
	},
	[369] = {
	.class_hid = BNXT_ULP_CLASS_HID_e19d,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 2150894592UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_SRC_ADDR }
	},
	[370] = {
	.class_hid = BNXT_ULP_CLASS_HID_d015,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 2150902784UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_SRC_ADDR }
	},
	[371] = {
	.class_hid = BNXT_ULP_CLASS_HID_8c09,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 4296281088UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_DST_ADDR }
	},
	[372] = {
	.class_hid = BNXT_ULP_CLASS_HID_be89,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 4296289280UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_DST_ADDR }
	},
	[373] = {
	.class_hid = BNXT_ULP_CLASS_HID_ddad,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 4298378240UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_DST_ADDR }
	},
	[374] = {
	.class_hid = BNXT_ULP_CLASS_HID_cc2d,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 4298386432UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_DST_ADDR }
	},
	[375] = {
	.class_hid = BNXT_ULP_CLASS_HID_a4d9,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 6443764736UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_DST_ADDR }
	},
	[376] = {
	.class_hid = BNXT_ULP_CLASS_HID_d759,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 6443772928UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_DST_ADDR }
	},
	[377] = {
	.class_hid = BNXT_ULP_CLASS_HID_f27d,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 6445861888UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_DST_ADDR }
	},
	[378] = {
	.class_hid = BNXT_ULP_CLASS_HID_e4fd,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 6445870080UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_2_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_I_IPV4_DST_ADDR }
	},
	[379] = {
	.class_hid = BNXT_ULP_CLASS_HID_ecf6,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 1313792UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC }
	},
	[380] = {
	.class_hid = BNXT_ULP_CLASS_HID_a732,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 1321984UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC }
	},
	[381] = {
	.class_hid = BNXT_ULP_CLASS_HID_c45e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 3410944UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC }
	},
	[382] = {
	.class_hid = BNXT_ULP_CLASS_HID_f5d6,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 3419136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC }
	},
	[383] = {
	.class_hid = BNXT_ULP_CLASS_HID_d4ba,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 538184704UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR }
	},
	[384] = {
	.class_hid = BNXT_ULP_CLASS_HID_aea6,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 538192896UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR }
	},
	[385] = {
	.class_hid = BNXT_ULP_CLASS_HID_cc02,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 540281856UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR }
	},
	[386] = {
	.class_hid = BNXT_ULP_CLASS_HID_fd9a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 540290048UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR }
	},
	[387] = {
	.class_hid = BNXT_ULP_CLASS_HID_a51a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 1075055616UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR }
	},
	[388] = {
	.class_hid = BNXT_ULP_CLASS_HID_d692,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 1075063808UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR }
	},
	[389] = {
	.class_hid = BNXT_ULP_CLASS_HID_cbde,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 1077152768UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR }
	},
	[390] = {
	.class_hid = BNXT_ULP_CLASS_HID_ce1a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 1077160960UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR }
	},
	[391] = {
	.class_hid = BNXT_ULP_CLASS_HID_ac8e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 1611926528UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR }
	},
	[392] = {
	.class_hid = BNXT_ULP_CLASS_HID_de06,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 1611934720UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR }
	},
	[393] = {
	.class_hid = BNXT_ULP_CLASS_HID_f382,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 1614023680UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR }
	},
	[394] = {
	.class_hid = BNXT_ULP_CLASS_HID_ed1a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 1614031872UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR }
	},
	[395] = {
	.class_hid = BNXT_ULP_CLASS_HID_9d6a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 2148797440UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[396] = {
	.class_hid = BNXT_ULP_CLASS_HID_cee2,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 2148805632UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[397] = {
	.class_hid = BNXT_ULP_CLASS_HID_ec0e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 2150894592UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[398] = {
	.class_hid = BNXT_ULP_CLASS_HID_dd86,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 2150902784UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[399] = {
	.class_hid = BNXT_ULP_CLASS_HID_852e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 2685668352UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[400] = {
	.class_hid = BNXT_ULP_CLASS_HID_b6a6,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 2685676544UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[401] = {
	.class_hid = BNXT_ULP_CLASS_HID_eb82,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 2687765504UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[402] = {
	.class_hid = BNXT_ULP_CLASS_HID_c50a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 2687773696UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[403] = {
	.class_hid = BNXT_ULP_CLASS_HID_ccca,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 3222539264UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[404] = {
	.class_hid = BNXT_ULP_CLASS_HID_8706,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 3222547456UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[405] = {
	.class_hid = BNXT_ULP_CLASS_HID_d38e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 3224636416UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[406] = {
	.class_hid = BNXT_ULP_CLASS_HID_d5ca,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 3224644608UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[407] = {
	.class_hid = BNXT_ULP_CLASS_HID_b48e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 3759410176UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[408] = {
	.class_hid = BNXT_ULP_CLASS_HID_8e8a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 3759418368UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[409] = {
	.class_hid = BNXT_ULP_CLASS_HID_db02,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 3761507328UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[410] = {
	.class_hid = BNXT_ULP_CLASS_HID_dd8e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 3761515520UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT }
	},
	[411] = {
	.class_hid = BNXT_ULP_CLASS_HID_819a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 4296281088UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[412] = {
	.class_hid = BNXT_ULP_CLASS_HID_b31a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 4296289280UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[413] = {
	.class_hid = BNXT_ULP_CLASS_HID_d03e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 4298378240UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[414] = {
	.class_hid = BNXT_ULP_CLASS_HID_c1be,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 4298386432UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[415] = {
	.class_hid = BNXT_ULP_CLASS_HID_890e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 4833152000UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[416] = {
	.class_hid = BNXT_ULP_CLASS_HID_ba8e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 4833160192UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[417] = {
	.class_hid = BNXT_ULP_CLASS_HID_dfaa,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 4835249152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[418] = {
	.class_hid = BNXT_ULP_CLASS_HID_c93a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 4835257344UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[419] = {
	.class_hid = BNXT_ULP_CLASS_HID_b11a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 5370022912UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[420] = {
	.class_hid = BNXT_ULP_CLASS_HID_8b4e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 5370031104UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[421] = {
	.class_hid = BNXT_ULP_CLASS_HID_c79e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 5372120064UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[422] = {
	.class_hid = BNXT_ULP_CLASS_HID_d9da,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 5372128256UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[423] = {
	.class_hid = BNXT_ULP_CLASS_HID_b88e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 5906893824UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[424] = {
	.class_hid = BNXT_ULP_CLASS_HID_ea0e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 5906902016UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[425] = {
	.class_hid = BNXT_ULP_CLASS_HID_cf0a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 5908990976UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[426] = {
	.class_hid = BNXT_ULP_CLASS_HID_c18e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 5908999168UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[427] = {
	.class_hid = BNXT_ULP_CLASS_HID_a94a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 6443764736UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[428] = {
	.class_hid = BNXT_ULP_CLASS_HID_daca,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 6443772928UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[429] = {
	.class_hid = BNXT_ULP_CLASS_HID_ffee,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 6445861888UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[430] = {
	.class_hid = BNXT_ULP_CLASS_HID_e96e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 6445870080UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[431] = {
	.class_hid = BNXT_ULP_CLASS_HID_910e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 6980635648UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[432] = {
	.class_hid = BNXT_ULP_CLASS_HID_c28e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 6980643840UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[433] = {
	.class_hid = BNXT_ULP_CLASS_HID_e7aa,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 6982732800UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[434] = {
	.class_hid = BNXT_ULP_CLASS_HID_d12a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 6982740992UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[435] = {
	.class_hid = BNXT_ULP_CLASS_HID_d8ca,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 7517506560UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[436] = {
	.class_hid = BNXT_ULP_CLASS_HID_930e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 7517514752UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[437] = {
	.class_hid = BNXT_ULP_CLASS_HID_ef4e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 7519603712UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[438] = {
	.class_hid = BNXT_ULP_CLASS_HID_e18a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 7519611904UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[439] = {
	.class_hid = BNXT_ULP_CLASS_HID_c08e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 8054377472UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[440] = {
	.class_hid = BNXT_ULP_CLASS_HID_9a8a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 8054385664UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[441] = {
	.class_hid = BNXT_ULP_CLASS_HID_d70a,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 8056474624UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[442] = {
	.class_hid = BNXT_ULP_CLASS_HID_e90e,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 8056482816UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_3_BITMASK_I_TCP_DST_PORT }
	},
	[443] = {
	.class_hid = BNXT_ULP_CLASS_HID_edd9,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 1313792UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC }
	},
	[444] = {
	.class_hid = BNXT_ULP_CLASS_HID_a61d,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 1321984UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC }
	},
	[445] = {
	.class_hid = BNXT_ULP_CLASS_HID_c571,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 3410944UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC }
	},
	[446] = {
	.class_hid = BNXT_ULP_CLASS_HID_f4f9,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 3419136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC }
	},
	[447] = {
	.class_hid = BNXT_ULP_CLASS_HID_9c45,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 2148797440UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR }
	},
	[448] = {
	.class_hid = BNXT_ULP_CLASS_HID_cfcd,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 2148805632UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR }
	},
	[449] = {
	.class_hid = BNXT_ULP_CLASS_HID_ed21,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 2150894592UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR }
	},
	[450] = {
	.class_hid = BNXT_ULP_CLASS_HID_dca9,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 2150902784UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR }
	},
	[451] = {
	.class_hid = BNXT_ULP_CLASS_HID_80b5,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 4296281088UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR }
	},
	[452] = {
	.class_hid = BNXT_ULP_CLASS_HID_b235,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 4296289280UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR }
	},
	[453] = {
	.class_hid = BNXT_ULP_CLASS_HID_d111,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 4298378240UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR }
	},
	[454] = {
	.class_hid = BNXT_ULP_CLASS_HID_c091,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 4298386432UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR }
	},
	[455] = {
	.class_hid = BNXT_ULP_CLASS_HID_a865,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 6443764736UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR }
	},
	[456] = {
	.class_hid = BNXT_ULP_CLASS_HID_dbe5,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 6443772928UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR }
	},
	[457] = {
	.class_hid = BNXT_ULP_CLASS_HID_fec1,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 6445861888UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR }
	},
	[458] = {
	.class_hid = BNXT_ULP_CLASS_HID_e841,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 6445870080UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR }
	},
	[459] = {
	.class_hid = BNXT_ULP_CLASS_HID_8e85,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 8591248384UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[460] = {
	.class_hid = BNXT_ULP_CLASS_HID_b80d,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 8591256576UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[461] = {
	.class_hid = BNXT_ULP_CLASS_HID_df65,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 8593345536UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[462] = {
	.class_hid = BNXT_ULP_CLASS_HID_ceed,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 8593353728UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[463] = {
	.class_hid = BNXT_ULP_CLASS_HID_9645,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 10738732032UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[464] = {
	.class_hid = BNXT_ULP_CLASS_HID_c1cd,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 10738740224UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[465] = {
	.class_hid = BNXT_ULP_CLASS_HID_e725,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 10740829184UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[466] = {
	.class_hid = BNXT_ULP_CLASS_HID_d6ad,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 10740837376UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[467] = {
	.class_hid = BNXT_ULP_CLASS_HID_9aa5,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 12886215680UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[468] = {
	.class_hid = BNXT_ULP_CLASS_HID_b425,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 12886223872UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[469] = {
	.class_hid = BNXT_ULP_CLASS_HID_eb05,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 12888312832UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[470] = {
	.class_hid = BNXT_ULP_CLASS_HID_da85,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 12888321024UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[471] = {
	.class_hid = BNXT_ULP_CLASS_HID_a265,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 15033699328UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[472] = {
	.class_hid = BNXT_ULP_CLASS_HID_dde5,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 15033707520UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[473] = {
	.class_hid = BNXT_ULP_CLASS_HID_f0c5,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 15035796480UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[474] = {
	.class_hid = BNXT_ULP_CLASS_HID_e245,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 15035804672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT }
	},
	[475] = {
	.class_hid = BNXT_ULP_CLASS_HID_8b8f,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 17181182976UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[476] = {
	.class_hid = BNXT_ULP_CLASS_HID_a517,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 17181191168UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[477] = {
	.class_hid = BNXT_ULP_CLASS_HID_d86b,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 17183280128UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[478] = {
	.class_hid = BNXT_ULP_CLASS_HID_cbf3,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 17183288320UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[479] = {
	.class_hid = BNXT_ULP_CLASS_HID_934f,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 19328666624UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[480] = {
	.class_hid = BNXT_ULP_CLASS_HID_c2c7,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 19328674816UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[481] = {
	.class_hid = BNXT_ULP_CLASS_HID_e02b,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 19330763776UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[482] = {
	.class_hid = BNXT_ULP_CLASS_HID_d3a3,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 19330771968UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[483] = {
	.class_hid = BNXT_ULP_CLASS_HID_87a7,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 21476150272UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[484] = {
	.class_hid = BNXT_ULP_CLASS_HID_b137,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 21476158464UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[485] = {
	.class_hid = BNXT_ULP_CLASS_HID_d403,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 21478247424UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[486] = {
	.class_hid = BNXT_ULP_CLASS_HID_c793,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 21478255616UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[487] = {
	.class_hid = BNXT_ULP_CLASS_HID_af67,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 23623633920UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[488] = {
	.class_hid = BNXT_ULP_CLASS_HID_dee7,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 23623642112UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[489] = {
	.class_hid = BNXT_ULP_CLASS_HID_fdc3,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 23625731072UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[490] = {
	.class_hid = BNXT_ULP_CLASS_HID_ef43,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 23625739264UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[491] = {
	.class_hid = BNXT_ULP_CLASS_HID_8dbf,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 25771117568UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[492] = {
	.class_hid = BNXT_ULP_CLASS_HID_bf07,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 25771125760UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[493] = {
	.class_hid = BNXT_ULP_CLASS_HID_d21f,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 25773214720UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[494] = {
	.class_hid = BNXT_ULP_CLASS_HID_cde7,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 25773222912UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[495] = {
	.class_hid = BNXT_ULP_CLASS_HID_956f,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 27918601216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[496] = {
	.class_hid = BNXT_ULP_CLASS_HID_c4c7,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 27918609408UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[497] = {
	.class_hid = BNXT_ULP_CLASS_HID_fbcf,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 27920698368UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[498] = {
	.class_hid = BNXT_ULP_CLASS_HID_d5a7,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 27920706560UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[499] = {
	.class_hid = BNXT_ULP_CLASS_HID_9957,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 30066084864UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[500] = {
	.class_hid = BNXT_ULP_CLASS_HID_cb27,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 30066093056UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[501] = {
	.class_hid = BNXT_ULP_CLASS_HID_ee37,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 30068182016UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[502] = {
	.class_hid = BNXT_ULP_CLASS_HID_d987,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 30068190208UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[503] = {
	.class_hid = BNXT_ULP_CLASS_HID_a107,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 32213568512UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[504] = {
	.class_hid = BNXT_ULP_CLASS_HID_d0e7,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 32213576704UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[505] = {
	.class_hid = BNXT_ULP_CLASS_HID_f7e7,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 32215665664UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[506] = {
	.class_hid = BNXT_ULP_CLASS_HID_c827,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 32215673856UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_I_TCP_DST_PORT }
	},
	[507] = {
	.class_hid = BNXT_ULP_CLASS_HID_f76a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 1313792UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC }
	},
	[508] = {
	.class_hid = BNXT_ULP_CLASS_HID_bcae,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 1321984UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC }
	},
	[509] = {
	.class_hid = BNXT_ULP_CLASS_HID_dfc2,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 3410944UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC }
	},
	[510] = {
	.class_hid = BNXT_ULP_CLASS_HID_ee4a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 3419136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC }
	},
	[511] = {
	.class_hid = BNXT_ULP_CLASS_HID_cf26,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 538184704UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR }
	},
	[512] = {
	.class_hid = BNXT_ULP_CLASS_HID_b53a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 538192896UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR }
	},
	[513] = {
	.class_hid = BNXT_ULP_CLASS_HID_d79e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 540281856UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR }
	},
	[514] = {
	.class_hid = BNXT_ULP_CLASS_HID_e606,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 540290048UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR }
	},
	[515] = {
	.class_hid = BNXT_ULP_CLASS_HID_be86,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 1075055616UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR }
	},
	[516] = {
	.class_hid = BNXT_ULP_CLASS_HID_cd0e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 1075063808UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR }
	},
	[517] = {
	.class_hid = BNXT_ULP_CLASS_HID_d042,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 1077152768UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR }
	},
	[518] = {
	.class_hid = BNXT_ULP_CLASS_HID_d586,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 1077160960UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR }
	},
	[519] = {
	.class_hid = BNXT_ULP_CLASS_HID_b712,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 1611926528UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR }
	},
	[520] = {
	.class_hid = BNXT_ULP_CLASS_HID_c59a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 1611934720UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR }
	},
	[521] = {
	.class_hid = BNXT_ULP_CLASS_HID_e81e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 1614023680UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR }
	},
	[522] = {
	.class_hid = BNXT_ULP_CLASS_HID_f686,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 1614031872UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR }
	},
	[523] = {
	.class_hid = BNXT_ULP_CLASS_HID_86f6,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 2148797440UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[524] = {
	.class_hid = BNXT_ULP_CLASS_HID_d57e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 2148805632UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[525] = {
	.class_hid = BNXT_ULP_CLASS_HID_f792,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 2150894592UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[526] = {
	.class_hid = BNXT_ULP_CLASS_HID_c61a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 2150902784UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[527] = {
	.class_hid = BNXT_ULP_CLASS_HID_9eb2,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 2685668352UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[528] = {
	.class_hid = BNXT_ULP_CLASS_HID_ad3a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 2685676544UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[529] = {
	.class_hid = BNXT_ULP_CLASS_HID_f01e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 2687765504UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[530] = {
	.class_hid = BNXT_ULP_CLASS_HID_de96,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 2687773696UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[531] = {
	.class_hid = BNXT_ULP_CLASS_HID_d756,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 3222539264UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[532] = {
	.class_hid = BNXT_ULP_CLASS_HID_9c9a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 3222547456UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[533] = {
	.class_hid = BNXT_ULP_CLASS_HID_c812,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 3224636416UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[534] = {
	.class_hid = BNXT_ULP_CLASS_HID_ce56,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 3224644608UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[535] = {
	.class_hid = BNXT_ULP_CLASS_HID_af12,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 3759410176UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[536] = {
	.class_hid = BNXT_ULP_CLASS_HID_9516,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 3759418368UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[537] = {
	.class_hid = BNXT_ULP_CLASS_HID_c09e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 3761507328UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[538] = {
	.class_hid = BNXT_ULP_CLASS_HID_c612,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 3761515520UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT }
	},
	[539] = {
	.class_hid = BNXT_ULP_CLASS_HID_9a06,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 4296281088UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[540] = {
	.class_hid = BNXT_ULP_CLASS_HID_a886,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 4296289280UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[541] = {
	.class_hid = BNXT_ULP_CLASS_HID_cba2,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 4298378240UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[542] = {
	.class_hid = BNXT_ULP_CLASS_HID_da22,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 4298386432UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[543] = {
	.class_hid = BNXT_ULP_CLASS_HID_9292,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 4833152000UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[544] = {
	.class_hid = BNXT_ULP_CLASS_HID_a112,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 4833160192UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[545] = {
	.class_hid = BNXT_ULP_CLASS_HID_c436,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 4835249152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[546] = {
	.class_hid = BNXT_ULP_CLASS_HID_d2a6,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 4835257344UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[547] = {
	.class_hid = BNXT_ULP_CLASS_HID_aa86,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 5370022912UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[548] = {
	.class_hid = BNXT_ULP_CLASS_HID_90d2,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 5370031104UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[549] = {
	.class_hid = BNXT_ULP_CLASS_HID_dc02,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 5372120064UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[550] = {
	.class_hid = BNXT_ULP_CLASS_HID_c246,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 5372128256UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[551] = {
	.class_hid = BNXT_ULP_CLASS_HID_a312,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 5906893824UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[552] = {
	.class_hid = BNXT_ULP_CLASS_HID_f192,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 5906902016UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[553] = {
	.class_hid = BNXT_ULP_CLASS_HID_d496,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 5908990976UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[554] = {
	.class_hid = BNXT_ULP_CLASS_HID_da12,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 5908999168UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[555] = {
	.class_hid = BNXT_ULP_CLASS_HID_b2d6,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 6443764736UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[556] = {
	.class_hid = BNXT_ULP_CLASS_HID_c156,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 6443772928UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[557] = {
	.class_hid = BNXT_ULP_CLASS_HID_e472,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 6445861888UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[558] = {
	.class_hid = BNXT_ULP_CLASS_HID_f2f2,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 6445870080UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[559] = {
	.class_hid = BNXT_ULP_CLASS_HID_8a92,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 6980635648UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[560] = {
	.class_hid = BNXT_ULP_CLASS_HID_d912,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 6980643840UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[561] = {
	.class_hid = BNXT_ULP_CLASS_HID_fc36,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 6982732800UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[562] = {
	.class_hid = BNXT_ULP_CLASS_HID_cab6,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 6982740992UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[563] = {
	.class_hid = BNXT_ULP_CLASS_HID_c356,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 7517506560UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[564] = {
	.class_hid = BNXT_ULP_CLASS_HID_8892,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 7517514752UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[565] = {
	.class_hid = BNXT_ULP_CLASS_HID_f4d2,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 7519603712UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[566] = {
	.class_hid = BNXT_ULP_CLASS_HID_fa16,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 7519611904UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[567] = {
	.class_hid = BNXT_ULP_CLASS_HID_db12,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 8054377472UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[568] = {
	.class_hid = BNXT_ULP_CLASS_HID_8116,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 8054385664UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[569] = {
	.class_hid = BNXT_ULP_CLASS_HID_cc96,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 8056474624UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[570] = {
	.class_hid = BNXT_ULP_CLASS_HID_f292,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 8056482816UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV6 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_I_UDP_DST_PORT }
	},
	[571] = {
	.class_hid = BNXT_ULP_CLASS_HID_e84d,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 1313792UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC }
	},
	[572] = {
	.class_hid = BNXT_ULP_CLASS_HID_a389,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 1321984UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC }
	},
	[573] = {
	.class_hid = BNXT_ULP_CLASS_HID_c0e5,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 3410944UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC }
	},
	[574] = {
	.class_hid = BNXT_ULP_CLASS_HID_f16d,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 3419136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC }
	},
	[575] = {
	.class_hid = BNXT_ULP_CLASS_HID_99d1,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 2148797440UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR }
	},
	[576] = {
	.class_hid = BNXT_ULP_CLASS_HID_ca59,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 2148805632UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR }
	},
	[577] = {
	.class_hid = BNXT_ULP_CLASS_HID_e8b5,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 2150894592UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR }
	},
	[578] = {
	.class_hid = BNXT_ULP_CLASS_HID_d93d,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 2150902784UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR }
	},
	[579] = {
	.class_hid = BNXT_ULP_CLASS_HID_8521,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 4296281088UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR }
	},
	[580] = {
	.class_hid = BNXT_ULP_CLASS_HID_b7a1,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 4296289280UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR }
	},
	[581] = {
	.class_hid = BNXT_ULP_CLASS_HID_d485,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 4298378240UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR }
	},
	[582] = {
	.class_hid = BNXT_ULP_CLASS_HID_c505,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 4298386432UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR }
	},
	[583] = {
	.class_hid = BNXT_ULP_CLASS_HID_adf1,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 6443764736UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR }
	},
	[584] = {
	.class_hid = BNXT_ULP_CLASS_HID_de71,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 6443772928UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR }
	},
	[585] = {
	.class_hid = BNXT_ULP_CLASS_HID_fb55,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 6445861888UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR }
	},
	[586] = {
	.class_hid = BNXT_ULP_CLASS_HID_edd5,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 6445870080UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR }
	},
	[587] = {
	.class_hid = BNXT_ULP_CLASS_HID_8b11,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 8591248384UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[588] = {
	.class_hid = BNXT_ULP_CLASS_HID_bd99,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 8591256576UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[589] = {
	.class_hid = BNXT_ULP_CLASS_HID_daf1,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 8593345536UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[590] = {
	.class_hid = BNXT_ULP_CLASS_HID_cb79,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 8593353728UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[591] = {
	.class_hid = BNXT_ULP_CLASS_HID_93d1,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 10738732032UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[592] = {
	.class_hid = BNXT_ULP_CLASS_HID_c459,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 10738740224UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[593] = {
	.class_hid = BNXT_ULP_CLASS_HID_e2b1,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 10740829184UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[594] = {
	.class_hid = BNXT_ULP_CLASS_HID_d339,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 10740837376UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[595] = {
	.class_hid = BNXT_ULP_CLASS_HID_9f31,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 12886215680UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[596] = {
	.class_hid = BNXT_ULP_CLASS_HID_b1b1,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 12886223872UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[597] = {
	.class_hid = BNXT_ULP_CLASS_HID_ee91,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 12888312832UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[598] = {
	.class_hid = BNXT_ULP_CLASS_HID_df11,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 12888321024UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[599] = {
	.class_hid = BNXT_ULP_CLASS_HID_a7f1,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 15033699328UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[600] = {
	.class_hid = BNXT_ULP_CLASS_HID_d871,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 15033707520UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[601] = {
	.class_hid = BNXT_ULP_CLASS_HID_f551,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 15035796480UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[602] = {
	.class_hid = BNXT_ULP_CLASS_HID_e7d1,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 15035804672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT }
	},
	[603] = {
	.class_hid = BNXT_ULP_CLASS_HID_8e1b,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 17181182976UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[604] = {
	.class_hid = BNXT_ULP_CLASS_HID_a083,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 17181191168UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[605] = {
	.class_hid = BNXT_ULP_CLASS_HID_ddff,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 17183280128UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[606] = {
	.class_hid = BNXT_ULP_CLASS_HID_ce67,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 17183288320UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[607] = {
	.class_hid = BNXT_ULP_CLASS_HID_96db,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 19328666624UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[608] = {
	.class_hid = BNXT_ULP_CLASS_HID_c753,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 19328674816UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[609] = {
	.class_hid = BNXT_ULP_CLASS_HID_e5bf,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 19330763776UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[610] = {
	.class_hid = BNXT_ULP_CLASS_HID_d637,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 19330771968UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[611] = {
	.class_hid = BNXT_ULP_CLASS_HID_8233,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 21476150272UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[612] = {
	.class_hid = BNXT_ULP_CLASS_HID_b4a3,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 21476158464UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[613] = {
	.class_hid = BNXT_ULP_CLASS_HID_d197,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 21478247424UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[614] = {
	.class_hid = BNXT_ULP_CLASS_HID_c207,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 21478255616UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[615] = {
	.class_hid = BNXT_ULP_CLASS_HID_aaf3,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 23623633920UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[616] = {
	.class_hid = BNXT_ULP_CLASS_HID_db73,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 23623642112UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[617] = {
	.class_hid = BNXT_ULP_CLASS_HID_f857,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 23625731072UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[618] = {
	.class_hid = BNXT_ULP_CLASS_HID_ead7,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 23625739264UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[619] = {
	.class_hid = BNXT_ULP_CLASS_HID_882b,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 25771117568UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[620] = {
	.class_hid = BNXT_ULP_CLASS_HID_ba93,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 25771125760UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[621] = {
	.class_hid = BNXT_ULP_CLASS_HID_d78b,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 25773214720UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[622] = {
	.class_hid = BNXT_ULP_CLASS_HID_c873,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 25773222912UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[623] = {
	.class_hid = BNXT_ULP_CLASS_HID_90fb,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 27918601216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[624] = {
	.class_hid = BNXT_ULP_CLASS_HID_c153,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 27918609408UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[625] = {
	.class_hid = BNXT_ULP_CLASS_HID_fe5b,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 27920698368UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[626] = {
	.class_hid = BNXT_ULP_CLASS_HID_d033,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 27920706560UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[627] = {
	.class_hid = BNXT_ULP_CLASS_HID_9cc3,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 30066084864UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[628] = {
	.class_hid = BNXT_ULP_CLASS_HID_ceb3,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 30066093056UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[629] = {
	.class_hid = BNXT_ULP_CLASS_HID_eba3,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 30068182016UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[630] = {
	.class_hid = BNXT_ULP_CLASS_HID_dc13,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 30068190208UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[631] = {
	.class_hid = BNXT_ULP_CLASS_HID_a493,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 32213568512UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[632] = {
	.class_hid = BNXT_ULP_CLASS_HID_d573,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 32213576704UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[633] = {
	.class_hid = BNXT_ULP_CLASS_HID_f273,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 32215665664UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[634] = {
	.class_hid = BNXT_ULP_CLASS_HID_cdb3,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 32215673856UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_I_UDP_DST_PORT }
	},
	[635] = {
	.class_hid = BNXT_ULP_CLASS_HID_ff35,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 1313792UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC }
	},
	[636] = {
	.class_hid = BNXT_ULP_CLASS_HID_b4f1,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 1321984UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC }
	},
	[637] = {
	.class_hid = BNXT_ULP_CLASS_HID_d79d,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 3410944UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_SMAC }
	},
	[638] = {
	.class_hid = BNXT_ULP_CLASS_HID_e615,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 3419136UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_SMAC }
	},
	[639] = {
	.class_hid = BNXT_ULP_CLASS_HID_8ea9,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 2148797440UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_SRC_ADDR }
	},
	[640] = {
	.class_hid = BNXT_ULP_CLASS_HID_dd21,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 2148805632UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_SRC_ADDR }
	},
	[641] = {
	.class_hid = BNXT_ULP_CLASS_HID_ffcd,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 2150894592UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_SRC_ADDR }
	},
	[642] = {
	.class_hid = BNXT_ULP_CLASS_HID_ce45,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 2150902784UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_SRC_ADDR }
	},
	[643] = {
	.class_hid = BNXT_ULP_CLASS_HID_9259,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 4296281088UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_DST_ADDR }
	},
	[644] = {
	.class_hid = BNXT_ULP_CLASS_HID_a0d9,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 4296289280UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_DST_ADDR }
	},
	[645] = {
	.class_hid = BNXT_ULP_CLASS_HID_c3fd,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 4298378240UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_DST_ADDR }
	},
	[646] = {
	.class_hid = BNXT_ULP_CLASS_HID_d27d,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 4298386432UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_DST_ADDR }
	},
	[647] = {
	.class_hid = BNXT_ULP_CLASS_HID_ba89,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 6443764736UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_DST_ADDR }
	},
	[648] = {
	.class_hid = BNXT_ULP_CLASS_HID_c909,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 6443772928UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_DST_ADDR }
	},
	[649] = {
	.class_hid = BNXT_ULP_CLASS_HID_ec2d,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 6445861888UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_DST_ADDR }
	},
	[650] = {
	.class_hid = BNXT_ULP_CLASS_HID_faad,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 6445870080UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_HDR_BIT_I_ETH |
		BNXT_ULP_HDR_BIT_I_IPV4 |
		BNXT_ULP_HDR_BIT_I_ICMP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_T_VXLAN_VNI |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_I_IPV4_DST_ADDR }
	},
	[651] = {
	.class_hid = BNXT_ULP_CLASS_HID_34c6,
	.class_tid = 3,
	.hdr_sig_id = 0,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[652] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c22,
	.class_tid = 3,
	.hdr_sig_id = 0,
	.flow_sig_id = 4100UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[653] = {
	.class_hid = BNXT_ULP_CLASS_HID_1cbe,
	.class_tid = 3,
	.hdr_sig_id = 0,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[654] = {
	.class_hid = BNXT_ULP_CLASS_HID_179a,
	.class_tid = 3,
	.hdr_sig_id = 0,
	.flow_sig_id = 6148UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[655] = {
	.class_hid = BNXT_ULP_CLASS_HID_59be,
	.class_tid = 3,
	.hdr_sig_id = 1,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[656] = {
	.class_hid = BNXT_ULP_CLASS_HID_515a,
	.class_tid = 3,
	.hdr_sig_id = 1,
	.flow_sig_id = 16388UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[657] = {
	.class_hid = BNXT_ULP_CLASS_HID_1c72,
	.class_tid = 3,
	.hdr_sig_id = 1,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[658] = {
	.class_hid = BNXT_ULP_CLASS_HID_171e,
	.class_tid = 3,
	.hdr_sig_id = 1,
	.flow_sig_id = 24580UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[659] = {
	.class_hid = BNXT_ULP_CLASS_HID_19c8,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[660] = {
	.class_hid = BNXT_ULP_CLASS_HID_112c,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 32772UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[661] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d68,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[662] = {
	.class_hid = BNXT_ULP_CLASS_HID_444c,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 32836UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[663] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e8c,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[664] = {
	.class_hid = BNXT_ULP_CLASS_HID_09e0,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 49156UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[665] = {
	.class_hid = BNXT_ULP_CLASS_HID_1af0,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[666] = {
	.class_hid = BNXT_ULP_CLASS_HID_15d4,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 49220UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[667] = {
	.class_hid = BNXT_ULP_CLASS_HID_1dd0,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[668] = {
	.class_hid = BNXT_ULP_CLASS_HID_14f4,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 131076UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[669] = {
	.class_hid = BNXT_ULP_CLASS_HID_70b0,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[670] = {
	.class_hid = BNXT_ULP_CLASS_HID_4854,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 131140UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[671] = {
	.class_hid = BNXT_ULP_CLASS_HID_3dd4,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[672] = {
	.class_hid = BNXT_ULP_CLASS_HID_34f8,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 196612UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[673] = {
	.class_hid = BNXT_ULP_CLASS_HID_09e8,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[674] = {
	.class_hid = BNXT_ULP_CLASS_HID_008c,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 196676UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[675] = {
	.class_hid = BNXT_ULP_CLASS_HID_34e6,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[676] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c02,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 4100UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[677] = {
	.class_hid = BNXT_ULP_CLASS_HID_1c9e,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[678] = {
	.class_hid = BNXT_ULP_CLASS_HID_17ba,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 6148UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[679] = {
	.class_hid = BNXT_ULP_CLASS_HID_429e,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 12288UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT }
	},
	[680] = {
	.class_hid = BNXT_ULP_CLASS_HID_5dba,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 12292UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT }
	},
	[681] = {
	.class_hid = BNXT_ULP_CLASS_HID_2a16,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 14336UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT }
	},
	[682] = {
	.class_hid = BNXT_ULP_CLASS_HID_2532,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 14340UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT }
	},
	[683] = {
	.class_hid = BNXT_ULP_CLASS_HID_2da2,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 20480UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[684] = {
	.class_hid = BNXT_ULP_CLASS_HID_24fe,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 20484UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[685] = {
	.class_hid = BNXT_ULP_CLASS_HID_355a,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 22528UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[686] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c76,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 22532UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[687] = {
	.class_hid = BNXT_ULP_CLASS_HID_13e6,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 28672UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[688] = {
	.class_hid = BNXT_ULP_CLASS_HID_7276,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 28676UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[689] = {
	.class_hid = BNXT_ULP_CLASS_HID_42d2,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 30720UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[690] = {
	.class_hid = BNXT_ULP_CLASS_HID_5dee,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 30724UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[691] = {
	.class_hid = BNXT_ULP_CLASS_HID_59de,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[692] = {
	.class_hid = BNXT_ULP_CLASS_HID_513a,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 16388UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[693] = {
	.class_hid = BNXT_ULP_CLASS_HID_1c12,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[694] = {
	.class_hid = BNXT_ULP_CLASS_HID_177e,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 24580UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[695] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e92,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT }
	},
	[696] = {
	.class_hid = BNXT_ULP_CLASS_HID_09fe,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 49156UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT }
	},
	[697] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c1a,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 57344UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT }
	},
	[698] = {
	.class_hid = BNXT_ULP_CLASS_HID_5746,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 57348UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT }
	},
	[699] = {
	.class_hid = BNXT_ULP_CLASS_HID_79da,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 81920UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[700] = {
	.class_hid = BNXT_ULP_CLASS_HID_7106,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 81924UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[701] = {
	.class_hid = BNXT_ULP_CLASS_HID_3c1e,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 90112UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[702] = {
	.class_hid = BNXT_ULP_CLASS_HID_377a,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 90116UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[703] = {
	.class_hid = BNXT_ULP_CLASS_HID_2e9e,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[704] = {
	.class_hid = BNXT_ULP_CLASS_HID_29fa,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 114692UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[705] = {
	.class_hid = BNXT_ULP_CLASS_HID_14d2,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 122880UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[706] = {
	.class_hid = BNXT_ULP_CLASS_HID_7742,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 122884UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[707] = {
	.class_hid = BNXT_ULP_CLASS_HID_3706,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[708] = {
	.class_hid = BNXT_ULP_CLASS_HID_0fe2,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 4100UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[709] = {
	.class_hid = BNXT_ULP_CLASS_HID_1f7e,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[710] = {
	.class_hid = BNXT_ULP_CLASS_HID_145a,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 6148UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[711] = {
	.class_hid = BNXT_ULP_CLASS_HID_417e,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 12288UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT }
	},
	[712] = {
	.class_hid = BNXT_ULP_CLASS_HID_5e5a,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 12292UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT }
	},
	[713] = {
	.class_hid = BNXT_ULP_CLASS_HID_29f6,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 14336UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT }
	},
	[714] = {
	.class_hid = BNXT_ULP_CLASS_HID_26d2,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 14340UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT }
	},
	[715] = {
	.class_hid = BNXT_ULP_CLASS_HID_2e42,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 20480UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[716] = {
	.class_hid = BNXT_ULP_CLASS_HID_271e,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 20484UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[717] = {
	.class_hid = BNXT_ULP_CLASS_HID_36ba,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 22528UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[718] = {
	.class_hid = BNXT_ULP_CLASS_HID_0f96,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 22532UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[719] = {
	.class_hid = BNXT_ULP_CLASS_HID_1006,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 28672UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[720] = {
	.class_hid = BNXT_ULP_CLASS_HID_7196,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 28676UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[721] = {
	.class_hid = BNXT_ULP_CLASS_HID_4132,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 30720UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[722] = {
	.class_hid = BNXT_ULP_CLASS_HID_5e0e,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 30724UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[723] = {
	.class_hid = BNXT_ULP_CLASS_HID_59fe,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[724] = {
	.class_hid = BNXT_ULP_CLASS_HID_511a,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 16388UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[725] = {
	.class_hid = BNXT_ULP_CLASS_HID_1c32,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[726] = {
	.class_hid = BNXT_ULP_CLASS_HID_175e,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 24580UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[727] = {
	.class_hid = BNXT_ULP_CLASS_HID_0eb2,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT }
	},
	[728] = {
	.class_hid = BNXT_ULP_CLASS_HID_09de,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 49156UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT }
	},
	[729] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c3a,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 57344UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT }
	},
	[730] = {
	.class_hid = BNXT_ULP_CLASS_HID_5766,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 57348UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT }
	},
	[731] = {
	.class_hid = BNXT_ULP_CLASS_HID_79fa,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 81920UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[732] = {
	.class_hid = BNXT_ULP_CLASS_HID_7126,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 81924UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[733] = {
	.class_hid = BNXT_ULP_CLASS_HID_3c3e,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 90112UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[734] = {
	.class_hid = BNXT_ULP_CLASS_HID_375a,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 90116UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[735] = {
	.class_hid = BNXT_ULP_CLASS_HID_2ebe,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[736] = {
	.class_hid = BNXT_ULP_CLASS_HID_29da,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 114692UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[737] = {
	.class_hid = BNXT_ULP_CLASS_HID_14f2,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 122880UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[738] = {
	.class_hid = BNXT_ULP_CLASS_HID_7762,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 122884UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[739] = {
	.class_hid = BNXT_ULP_CLASS_HID_19e8,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[740] = {
	.class_hid = BNXT_ULP_CLASS_HID_110c,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 32772UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[741] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d48,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[742] = {
	.class_hid = BNXT_ULP_CLASS_HID_446c,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 32836UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[743] = {
	.class_hid = BNXT_ULP_CLASS_HID_0eac,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[744] = {
	.class_hid = BNXT_ULP_CLASS_HID_09c0,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 49156UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[745] = {
	.class_hid = BNXT_ULP_CLASS_HID_1ad0,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[746] = {
	.class_hid = BNXT_ULP_CLASS_HID_15f4,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 49220UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[747] = {
	.class_hid = BNXT_ULP_CLASS_HID_39ec,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 98304UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[748] = {
	.class_hid = BNXT_ULP_CLASS_HID_3100,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 98308UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[749] = {
	.class_hid = BNXT_ULP_CLASS_HID_0210,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 98368UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[750] = {
	.class_hid = BNXT_ULP_CLASS_HID_1d34,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 98372UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[751] = {
	.class_hid = BNXT_ULP_CLASS_HID_2ea0,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[752] = {
	.class_hid = BNXT_ULP_CLASS_HID_29c4,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 114692UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[753] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ad4,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 114752UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[754] = {
	.class_hid = BNXT_ULP_CLASS_HID_35e8,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 114756UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[755] = {
	.class_hid = BNXT_ULP_CLASS_HID_5d80,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 163840UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[756] = {
	.class_hid = BNXT_ULP_CLASS_HID_54a4,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 163844UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[757] = {
	.class_hid = BNXT_ULP_CLASS_HID_29b4,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 163904UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[758] = {
	.class_hid = BNXT_ULP_CLASS_HID_20c8,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 163908UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[759] = {
	.class_hid = BNXT_ULP_CLASS_HID_7244,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 180224UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[760] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d98,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 180228UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[761] = {
	.class_hid = BNXT_ULP_CLASS_HID_5e68,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 180288UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[762] = {
	.class_hid = BNXT_ULP_CLASS_HID_598c,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 180292UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[763] = {
	.class_hid = BNXT_ULP_CLASS_HID_1248,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 229376UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[764] = {
	.class_hid = BNXT_ULP_CLASS_HID_74d8,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 229380UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[765] = {
	.class_hid = BNXT_ULP_CLASS_HID_49a8,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 229440UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[766] = {
	.class_hid = BNXT_ULP_CLASS_HID_40cc,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 229444UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[767] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b0c,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 245760UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[768] = {
	.class_hid = BNXT_ULP_CLASS_HID_0220,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 245764UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[769] = {
	.class_hid = BNXT_ULP_CLASS_HID_1730,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 245824UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[770] = {
	.class_hid = BNXT_ULP_CLASS_HID_7980,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 245828UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[771] = {
	.class_hid = BNXT_ULP_CLASS_HID_1db0,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[772] = {
	.class_hid = BNXT_ULP_CLASS_HID_1494,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 131076UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[773] = {
	.class_hid = BNXT_ULP_CLASS_HID_70d0,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[774] = {
	.class_hid = BNXT_ULP_CLASS_HID_4834,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 131140UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[775] = {
	.class_hid = BNXT_ULP_CLASS_HID_3db4,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[776] = {
	.class_hid = BNXT_ULP_CLASS_HID_3498,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 196612UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[777] = {
	.class_hid = BNXT_ULP_CLASS_HID_0988,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[778] = {
	.class_hid = BNXT_ULP_CLASS_HID_00ec,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 196676UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[779] = {
	.class_hid = BNXT_ULP_CLASS_HID_3f44,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 393216UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[780] = {
	.class_hid = BNXT_ULP_CLASS_HID_36a8,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 393220UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[781] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b58,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 393280UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[782] = {
	.class_hid = BNXT_ULP_CLASS_HID_02bc,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 393284UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[783] = {
	.class_hid = BNXT_ULP_CLASS_HID_5f48,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 458752UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[784] = {
	.class_hid = BNXT_ULP_CLASS_HID_56ac,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 458756UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[785] = {
	.class_hid = BNXT_ULP_CLASS_HID_2b5c,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 458816UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[786] = {
	.class_hid = BNXT_ULP_CLASS_HID_2280,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 458820UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[787] = {
	.class_hid = BNXT_ULP_CLASS_HID_4000,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 655360UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[788] = {
	.class_hid = BNXT_ULP_CLASS_HID_5b64,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 655364UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[789] = {
	.class_hid = BNXT_ULP_CLASS_HID_2c14,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 655424UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[790] = {
	.class_hid = BNXT_ULP_CLASS_HID_2778,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 655428UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[791] = {
	.class_hid = BNXT_ULP_CLASS_HID_18f8,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 720896UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[792] = {
	.class_hid = BNXT_ULP_CLASS_HID_13dc,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 720900UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[793] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c18,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 720960UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[794] = {
	.class_hid = BNXT_ULP_CLASS_HID_477c,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 720964UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[795] = {
	.class_hid = BNXT_ULP_CLASS_HID_1a88,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 917504UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[796] = {
	.class_hid = BNXT_ULP_CLASS_HID_15ec,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 917508UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[797] = {
	.class_hid = BNXT_ULP_CLASS_HID_4e28,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 917568UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[798] = {
	.class_hid = BNXT_ULP_CLASS_HID_490c,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 917572UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[799] = {
	.class_hid = BNXT_ULP_CLASS_HID_3a8c,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 983040UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[800] = {
	.class_hid = BNXT_ULP_CLASS_HID_35f0,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 983044UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[801] = {
	.class_hid = BNXT_ULP_CLASS_HID_06e0,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 983104UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[802] = {
	.class_hid = BNXT_ULP_CLASS_HID_01c4,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 983108UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[803] = {
	.class_hid = BNXT_ULP_CLASS_HID_1a08,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[804] = {
	.class_hid = BNXT_ULP_CLASS_HID_12ec,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 32772UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[805] = {
	.class_hid = BNXT_ULP_CLASS_HID_4ea8,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[806] = {
	.class_hid = BNXT_ULP_CLASS_HID_478c,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 32836UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[807] = {
	.class_hid = BNXT_ULP_CLASS_HID_0d4c,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[808] = {
	.class_hid = BNXT_ULP_CLASS_HID_0a20,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 49156UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[809] = {
	.class_hid = BNXT_ULP_CLASS_HID_1930,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[810] = {
	.class_hid = BNXT_ULP_CLASS_HID_1614,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 49220UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[811] = {
	.class_hid = BNXT_ULP_CLASS_HID_3a0c,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 98304UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[812] = {
	.class_hid = BNXT_ULP_CLASS_HID_32e0,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 98308UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[813] = {
	.class_hid = BNXT_ULP_CLASS_HID_01f0,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 98368UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[814] = {
	.class_hid = BNXT_ULP_CLASS_HID_1ed4,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 98372UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[815] = {
	.class_hid = BNXT_ULP_CLASS_HID_2d40,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[816] = {
	.class_hid = BNXT_ULP_CLASS_HID_2a24,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 114692UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[817] = {
	.class_hid = BNXT_ULP_CLASS_HID_3934,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 114752UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[818] = {
	.class_hid = BNXT_ULP_CLASS_HID_3608,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 114756UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[819] = {
	.class_hid = BNXT_ULP_CLASS_HID_5e60,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 163840UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[820] = {
	.class_hid = BNXT_ULP_CLASS_HID_5744,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 163844UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[821] = {
	.class_hid = BNXT_ULP_CLASS_HID_2a54,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 163904UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[822] = {
	.class_hid = BNXT_ULP_CLASS_HID_2328,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 163908UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[823] = {
	.class_hid = BNXT_ULP_CLASS_HID_71a4,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 180224UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[824] = {
	.class_hid = BNXT_ULP_CLASS_HID_4e78,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 180228UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[825] = {
	.class_hid = BNXT_ULP_CLASS_HID_5d88,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 180288UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[826] = {
	.class_hid = BNXT_ULP_CLASS_HID_5a6c,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 180292UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[827] = {
	.class_hid = BNXT_ULP_CLASS_HID_11a8,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 229376UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[828] = {
	.class_hid = BNXT_ULP_CLASS_HID_7738,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 229380UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[829] = {
	.class_hid = BNXT_ULP_CLASS_HID_4a48,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 229440UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[830] = {
	.class_hid = BNXT_ULP_CLASS_HID_432c,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 229444UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[831] = {
	.class_hid = BNXT_ULP_CLASS_HID_08ec,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 245760UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[832] = {
	.class_hid = BNXT_ULP_CLASS_HID_01c0,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 245764UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[833] = {
	.class_hid = BNXT_ULP_CLASS_HID_14d0,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 245824UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[834] = {
	.class_hid = BNXT_ULP_CLASS_HID_7a60,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 245828UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[835] = {
	.class_hid = BNXT_ULP_CLASS_HID_1d90,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[836] = {
	.class_hid = BNXT_ULP_CLASS_HID_14b4,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 131076UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[837] = {
	.class_hid = BNXT_ULP_CLASS_HID_70f0,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[838] = {
	.class_hid = BNXT_ULP_CLASS_HID_4814,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 131140UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[839] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d94,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[840] = {
	.class_hid = BNXT_ULP_CLASS_HID_34b8,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 196612UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[841] = {
	.class_hid = BNXT_ULP_CLASS_HID_09a8,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[842] = {
	.class_hid = BNXT_ULP_CLASS_HID_00cc,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 196676UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[843] = {
	.class_hid = BNXT_ULP_CLASS_HID_3f64,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 393216UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[844] = {
	.class_hid = BNXT_ULP_CLASS_HID_3688,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 393220UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[845] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b78,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 393280UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[846] = {
	.class_hid = BNXT_ULP_CLASS_HID_029c,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 393284UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[847] = {
	.class_hid = BNXT_ULP_CLASS_HID_5f68,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 458752UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[848] = {
	.class_hid = BNXT_ULP_CLASS_HID_568c,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 458756UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[849] = {
	.class_hid = BNXT_ULP_CLASS_HID_2b7c,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 458816UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[850] = {
	.class_hid = BNXT_ULP_CLASS_HID_22a0,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 458820UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[851] = {
	.class_hid = BNXT_ULP_CLASS_HID_4020,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 655360UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[852] = {
	.class_hid = BNXT_ULP_CLASS_HID_5b44,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 655364UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[853] = {
	.class_hid = BNXT_ULP_CLASS_HID_2c34,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 655424UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[854] = {
	.class_hid = BNXT_ULP_CLASS_HID_2758,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 655428UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[855] = {
	.class_hid = BNXT_ULP_CLASS_HID_18d8,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 720896UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[856] = {
	.class_hid = BNXT_ULP_CLASS_HID_13fc,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 720900UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[857] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c38,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 720960UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[858] = {
	.class_hid = BNXT_ULP_CLASS_HID_475c,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 720964UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[859] = {
	.class_hid = BNXT_ULP_CLASS_HID_1aa8,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 917504UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[860] = {
	.class_hid = BNXT_ULP_CLASS_HID_15cc,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 917508UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[861] = {
	.class_hid = BNXT_ULP_CLASS_HID_4e08,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 917568UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[862] = {
	.class_hid = BNXT_ULP_CLASS_HID_492c,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 917572UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[863] = {
	.class_hid = BNXT_ULP_CLASS_HID_3aac,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 983040UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[864] = {
	.class_hid = BNXT_ULP_CLASS_HID_35d0,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 983044UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[865] = {
	.class_hid = BNXT_ULP_CLASS_HID_06c0,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 983104UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[866] = {
	.class_hid = BNXT_ULP_CLASS_HID_01e4,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 983108UL,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[867] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d32,
	.class_tid = 3,
	.hdr_sig_id = 0,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[868] = {
	.class_hid = BNXT_ULP_CLASS_HID_54aa,
	.class_tid = 3,
	.hdr_sig_id = 0,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[869] = {
	.class_hid = BNXT_ULP_CLASS_HID_0686,
	.class_tid = 3,
	.hdr_sig_id = 1,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[870] = {
	.class_hid = BNXT_ULP_CLASS_HID_540e,
	.class_tid = 3,
	.hdr_sig_id = 1,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[871] = {
	.class_hid = BNXT_ULP_CLASS_HID_2e3c,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[872] = {
	.class_hid = BNXT_ULP_CLASS_HID_3a20,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[873] = {
	.class_hid = BNXT_ULP_CLASS_HID_46f0,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[874] = {
	.class_hid = BNXT_ULP_CLASS_HID_52e4,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[875] = {
	.class_hid = BNXT_ULP_CLASS_HID_55e4,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[876] = {
	.class_hid = BNXT_ULP_CLASS_HID_21f8,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[877] = {
	.class_hid = BNXT_ULP_CLASS_HID_75e8,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[878] = {
	.class_hid = BNXT_ULP_CLASS_HID_41fc,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[879] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d12,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[880] = {
	.class_hid = BNXT_ULP_CLASS_HID_548a,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[881] = {
	.class_hid = BNXT_ULP_CLASS_HID_3356,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 12288UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT }
	},
	[882] = {
	.class_hid = BNXT_ULP_CLASS_HID_1ace,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 14336UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT }
	},
	[883] = {
	.class_hid = BNXT_ULP_CLASS_HID_1a9a,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 20480UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[884] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d46,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 22528UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[885] = {
	.class_hid = BNXT_ULP_CLASS_HID_2812,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 28672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[886] = {
	.class_hid = BNXT_ULP_CLASS_HID_338a,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 30720UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_4_BITMASK_O_TCP_DST_PORT }
	},
	[887] = {
	.class_hid = BNXT_ULP_CLASS_HID_06e6,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[888] = {
	.class_hid = BNXT_ULP_CLASS_HID_546e,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[889] = {
	.class_hid = BNXT_ULP_CLASS_HID_46ee,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT }
	},
	[890] = {
	.class_hid = BNXT_ULP_CLASS_HID_0d22,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 57344UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT }
	},
	[891] = {
	.class_hid = BNXT_ULP_CLASS_HID_26e2,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 81920UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[892] = {
	.class_hid = BNXT_ULP_CLASS_HID_746a,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 90112UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[893] = {
	.class_hid = BNXT_ULP_CLASS_HID_1fa6,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[894] = {
	.class_hid = BNXT_ULP_CLASS_HID_2d2e,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 122880UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_5_BITMASK_O_TCP_DST_PORT }
	},
	[895] = {
	.class_hid = BNXT_ULP_CLASS_HID_4ef2,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 4096UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[896] = {
	.class_hid = BNXT_ULP_CLASS_HID_576a,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 6144UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[897] = {
	.class_hid = BNXT_ULP_CLASS_HID_30b6,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 12288UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT }
	},
	[898] = {
	.class_hid = BNXT_ULP_CLASS_HID_192e,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 14336UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT }
	},
	[899] = {
	.class_hid = BNXT_ULP_CLASS_HID_197a,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 20480UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[900] = {
	.class_hid = BNXT_ULP_CLASS_HID_4ea6,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 22528UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[901] = {
	.class_hid = BNXT_ULP_CLASS_HID_2bf2,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 28672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[902] = {
	.class_hid = BNXT_ULP_CLASS_HID_306a,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 30720UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_6_BITMASK_O_UDP_DST_PORT }
	},
	[903] = {
	.class_hid = BNXT_ULP_CLASS_HID_06c6,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 16384UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[904] = {
	.class_hid = BNXT_ULP_CLASS_HID_544e,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 24576UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[905] = {
	.class_hid = BNXT_ULP_CLASS_HID_46ce,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT }
	},
	[906] = {
	.class_hid = BNXT_ULP_CLASS_HID_0d02,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 57344UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT }
	},
	[907] = {
	.class_hid = BNXT_ULP_CLASS_HID_26c2,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 81920UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[908] = {
	.class_hid = BNXT_ULP_CLASS_HID_744a,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 90112UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[909] = {
	.class_hid = BNXT_ULP_CLASS_HID_1f86,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[910] = {
	.class_hid = BNXT_ULP_CLASS_HID_2d0e,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 122880UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_7_BITMASK_O_UDP_DST_PORT }
	},
	[911] = {
	.class_hid = BNXT_ULP_CLASS_HID_2e1c,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[912] = {
	.class_hid = BNXT_ULP_CLASS_HID_3a00,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[913] = {
	.class_hid = BNXT_ULP_CLASS_HID_46d0,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[914] = {
	.class_hid = BNXT_ULP_CLASS_HID_52c4,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[915] = {
	.class_hid = BNXT_ULP_CLASS_HID_4e10,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 98304UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[916] = {
	.class_hid = BNXT_ULP_CLASS_HID_5a04,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 98368UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[917] = {
	.class_hid = BNXT_ULP_CLASS_HID_1f98,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[918] = {
	.class_hid = BNXT_ULP_CLASS_HID_72f8,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 114752UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT }
	},
	[919] = {
	.class_hid = BNXT_ULP_CLASS_HID_0a78,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 163840UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[920] = {
	.class_hid = BNXT_ULP_CLASS_HID_166c,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 163904UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[921] = {
	.class_hid = BNXT_ULP_CLASS_HID_233c,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 180224UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[922] = {
	.class_hid = BNXT_ULP_CLASS_HID_0f20,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 180288UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[923] = {
	.class_hid = BNXT_ULP_CLASS_HID_2a7c,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 229376UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[924] = {
	.class_hid = BNXT_ULP_CLASS_HID_3660,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 229440UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[925] = {
	.class_hid = BNXT_ULP_CLASS_HID_4330,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 245760UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[926] = {
	.class_hid = BNXT_ULP_CLASS_HID_2f24,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 245824UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_8_BITMASK_O_TCP_DST_PORT }
	},
	[927] = {
	.class_hid = BNXT_ULP_CLASS_HID_5584,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[928] = {
	.class_hid = BNXT_ULP_CLASS_HID_2198,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[929] = {
	.class_hid = BNXT_ULP_CLASS_HID_7588,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[930] = {
	.class_hid = BNXT_ULP_CLASS_HID_419c,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[931] = {
	.class_hid = BNXT_ULP_CLASS_HID_7758,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 393216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[932] = {
	.class_hid = BNXT_ULP_CLASS_HID_43ac,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 393280UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[933] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c10,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 458752UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[934] = {
	.class_hid = BNXT_ULP_CLASS_HID_1864,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 458816UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT }
	},
	[935] = {
	.class_hid = BNXT_ULP_CLASS_HID_30c8,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 655360UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[936] = {
	.class_hid = BNXT_ULP_CLASS_HID_1cdc,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 655424UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[937] = {
	.class_hid = BNXT_ULP_CLASS_HID_50cc,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 720896UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[938] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d20,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 720960UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[939] = {
	.class_hid = BNXT_ULP_CLASS_HID_529c,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 917504UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[940] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ef0,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 917568UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[941] = {
	.class_hid = BNXT_ULP_CLASS_HID_72e0,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 983040UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[942] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ef4,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 983104UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_3_9_BITMASK_O_TCP_DST_PORT }
	},
	[943] = {
	.class_hid = BNXT_ULP_CLASS_HID_2dfc,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 32768UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[944] = {
	.class_hid = BNXT_ULP_CLASS_HID_39e0,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 32832UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[945] = {
	.class_hid = BNXT_ULP_CLASS_HID_4530,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 49152UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[946] = {
	.class_hid = BNXT_ULP_CLASS_HID_5124,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 49216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[947] = {
	.class_hid = BNXT_ULP_CLASS_HID_4df0,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 98304UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[948] = {
	.class_hid = BNXT_ULP_CLASS_HID_59e4,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 98368UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[949] = {
	.class_hid = BNXT_ULP_CLASS_HID_1c78,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 114688UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[950] = {
	.class_hid = BNXT_ULP_CLASS_HID_7118,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 114752UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT }
	},
	[951] = {
	.class_hid = BNXT_ULP_CLASS_HID_0998,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 163840UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[952] = {
	.class_hid = BNXT_ULP_CLASS_HID_158c,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 163904UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[953] = {
	.class_hid = BNXT_ULP_CLASS_HID_20dc,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 180224UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[954] = {
	.class_hid = BNXT_ULP_CLASS_HID_0cc0,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 180288UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[955] = {
	.class_hid = BNXT_ULP_CLASS_HID_299c,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 229376UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[956] = {
	.class_hid = BNXT_ULP_CLASS_HID_3580,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 229440UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[957] = {
	.class_hid = BNXT_ULP_CLASS_HID_40d0,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 245760UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[958] = {
	.class_hid = BNXT_ULP_CLASS_HID_2cc4,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 245824UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_10_BITMASK_O_UDP_DST_PORT }
	},
	[959] = {
	.class_hid = BNXT_ULP_CLASS_HID_55a4,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 131072UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[960] = {
	.class_hid = BNXT_ULP_CLASS_HID_21b8,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 131136UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[961] = {
	.class_hid = BNXT_ULP_CLASS_HID_75a8,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 196608UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[962] = {
	.class_hid = BNXT_ULP_CLASS_HID_41bc,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 196672UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[963] = {
	.class_hid = BNXT_ULP_CLASS_HID_7778,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 393216UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[964] = {
	.class_hid = BNXT_ULP_CLASS_HID_438c,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 393280UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[965] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c30,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 458752UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[966] = {
	.class_hid = BNXT_ULP_CLASS_HID_1844,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 458816UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT }
	},
	[967] = {
	.class_hid = BNXT_ULP_CLASS_HID_30e8,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 655360UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[968] = {
	.class_hid = BNXT_ULP_CLASS_HID_1cfc,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 655424UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[969] = {
	.class_hid = BNXT_ULP_CLASS_HID_50ec,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 720896UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[970] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d00,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 720960UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[971] = {
	.class_hid = BNXT_ULP_CLASS_HID_52bc,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 917504UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[972] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ed0,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 917568UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[973] = {
	.class_hid = BNXT_ULP_CLASS_HID_72c0,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 983040UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[974] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ed4,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 983104UL,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_3_11_BITMASK_O_UDP_DST_PORT }
	},
	[975] = {
	.class_hid = BNXT_ULP_CLASS_HID_3866,
	.class_tid = 3,
	.hdr_sig_id = 0,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_0_BITMASK_O_ETH_SMAC }
	},
	[976] = {
	.class_hid = BNXT_ULP_CLASS_HID_381e,
	.class_tid = 3,
	.hdr_sig_id = 1,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_1_BITMASK_O_ETH_SMAC }
	},
	[977] = {
	.class_hid = BNXT_ULP_CLASS_HID_3860,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_SMAC }
	},
	[978] = {
	.class_hid = BNXT_ULP_CLASS_HID_0454,
	.class_tid = 3,
	.hdr_sig_id = 2,
	.flow_sig_id = 68UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_2_BITMASK_OO_VLAN_VID }
	},
	[979] = {
	.class_hid = BNXT_ULP_CLASS_HID_3818,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_SMAC }
	},
	[980] = {
	.class_hid = BNXT_ULP_CLASS_HID_042c,
	.class_tid = 3,
	.hdr_sig_id = 3,
	.flow_sig_id = 68UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_3_BITMASK_OO_VLAN_VID }
	},
	[981] = {
	.class_hid = BNXT_ULP_CLASS_HID_3846,
	.class_tid = 3,
	.hdr_sig_id = 4,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_4_BITMASK_O_ETH_SMAC }
	},
	[982] = {
	.class_hid = BNXT_ULP_CLASS_HID_387e,
	.class_tid = 3,
	.hdr_sig_id = 5,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_5_BITMASK_O_ETH_SMAC }
	},
	[983] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ba6,
	.class_tid = 3,
	.hdr_sig_id = 6,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_6_BITMASK_O_ETH_SMAC }
	},
	[984] = {
	.class_hid = BNXT_ULP_CLASS_HID_385e,
	.class_tid = 3,
	.hdr_sig_id = 7,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_7_BITMASK_O_ETH_SMAC }
	},
	[985] = {
	.class_hid = BNXT_ULP_CLASS_HID_3840,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC }
	},
	[986] = {
	.class_hid = BNXT_ULP_CLASS_HID_0474,
	.class_tid = 3,
	.hdr_sig_id = 8,
	.flow_sig_id = 68UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_8_BITMASK_OO_VLAN_VID }
	},
	[987] = {
	.class_hid = BNXT_ULP_CLASS_HID_3878,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC }
	},
	[988] = {
	.class_hid = BNXT_ULP_CLASS_HID_044c,
	.class_tid = 3,
	.hdr_sig_id = 9,
	.flow_sig_id = 68UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_9_BITMASK_OO_VLAN_VID }
	},
	[989] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ba0,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC }
	},
	[990] = {
	.class_hid = BNXT_ULP_CLASS_HID_0794,
	.class_tid = 3,
	.hdr_sig_id = 10,
	.flow_sig_id = 68UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_10_BITMASK_OO_VLAN_VID }
	},
	[991] = {
	.class_hid = BNXT_ULP_CLASS_HID_3858,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 4UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC }
	},
	[992] = {
	.class_hid = BNXT_ULP_CLASS_HID_046c,
	.class_tid = 3,
	.hdr_sig_id = 11,
	.flow_sig_id = 68UL,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_3_11_BITMASK_OO_VLAN_VID }
	}
};
